/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: def_par.hpp,v 1.1 2005/07/25 16:31:44 bellinpo Exp $ */


#ifndef DEF_PAR_HPP
#define DEF_PAR_HPP

#define DIM_FIELD_SymCmd sizeof(short)
#define LENGTH_COMMANDID sizeof(short int)
#define LENGTH_SELECTIONTYPE sizeof(short int)
#define LENGTH_SELOBJTYPE sizeof(short int)
#define LENGTH_PATH1 (sizeof(short int)*PATH_LENGTH)
#define LENGTH_PATH2 (sizeof(short int)*PATH_LENGTH)
#define LENGTH_ARGV (sizeof(short int)*SYM_MAXARG)
#define LENGTH_TEXT (sizeof(short int)*SYM_MAX_TEXT)
#define LENGTH_STRING_COMMAND (LENGTH_COMMANDID+LENGTH_SELECTIONTYPE+LENGTH_SELOBJTYPE+LENGTH_PATH1+LENGTH_PATH2+LENGTH_ARGV+LENGTH_TEXT)

enum StateImpag 
{
	BEGIN_ESEC,
		BEGIN_IMP,
		END_BATT_IMP,
		END_BATT_IMP_FIRST,
		END_BATT_ESEC,
		END_IMP
};

enum StateExecution
{
	IMPAGINAZIONE,
		INIT_ESECUZIONE,
		JUMP_ESECUZIONE,
		ESECUZIONE
};


enum SaveType
{
	MDS_SAVE,
		ACL_SAVE_CONG,
		ACL_SAVE_SEP
};



#endif //DEF_PAR_HPP

