/* $Id: all.hpp,v 1.1 2005/07/25 09:36:09 bellinpo Exp $ */

 
#include "lioo.hpp"
#include "liooext.hpp"
#include "par/partitur.hpp"



#include "fig/nbreve.hpp"
#include "fig/nsemibre.hpp"
#include "fig/nminima.hpp"
#include "fig/nsemimin.hpp"
#include "fig/ncroma.hpp"
#include "fig/nsemicro.hpp"
#include "fig/nbiscrom.hpp"
#include "fig/nsemibis.hpp"
#include "fig/nfusa.hpp"

#include "fig/psemibre.hpp"
#include "fig/pminima.hpp"
#include "fig/psemimin.hpp"
#include "fig/pcroma.hpp"
#include "fig/psemicro.hpp"
#include "fig/pbiscrom.hpp"
#include "fig/psemibis.hpp"
#include "fig/pfusa.hpp"
#include "fig/pgeneric.hpp"
#include "fig/pquabatt.hpp"
#include "fig/pduebatt.hpp"
#include "fig/spazio.hpp"
#include "fig/accordo.hpp"
#include "fig/gruppono.hpp"
#include "fig/riptempo.hpp"
#include "fig/ripmbat.hpp"
#include "fig/ripbatt.hpp"

#include "bat/cviolino.hpp" 
#include "bat/cbasso.hpp" 
#include "bat/cbariton.hpp" 
#include "bat/ccontral.hpp" 
#include "bat/ctenore.hpp" 
#include "bat/cmezzoso.hpp" 
#include "bat/csoprano.hpp" 
#include "bat/cviolin8.hpp"
#include "bat/cbasso8.hpp"
#include "bat/chiave.hpp"
//
#include "bat/cbasso8sopra.hpp"
#include "bat/ctab.hpp"
#include "bat/cpercusbox.hpp"
#include "bat/cpercus2lines.hpp"
#include "bat/cvuota.hpp"
#include "bat/cbassoold.hpp"
#include "bat/ctenore8.hpp"
#include "bat/cviolino8sopra.hpp"
//

#include "alt/altecomp.hpp"
#include "alt/diesis.hpp"
#include "alt/bemolle.hpp"
#include "alt/bequadro.hpp"
#include "alt/doppiobe.hpp"
#include "alt/doppiodi.hpp"

#include "var/puntoval.hpp"
#include "var/corona.hpp"
#include "var/prfiato.hpp"
#include "var/occhiali.hpp"
#include "var/prfiato.hpp"


#include "ind/accento.hpp"
#include "ind/sforzato.hpp"
#include "ind/viasord.hpp"
#include "ind/consord.hpp"
#include "ind/martella.hpp"
#include "ind/espressi.hpp"
#include "ind/esprcomp.hpp"
#include "ind/indicazi.hpp"
#include "ind/tenuto.hpp"
#include "ind/puntoall.hpp"
#include "ind/espgenerica.hpp"

#include "ind/sforzato.hpp"
#include "ind/staccato.hpp"
#include "ind/martdolc.hpp"

#include "ind/armonici.hpp"
#include "ind/esprcomp.hpp"


#include "abb/trillo.hpp"
#include "abb/ginferio.hpp"
#include "abb/gsuperio.hpp"
#include "abb/minferio.hpp"
#include "abb/msuperio.hpp"

#include "ind/diteggia.hpp"
#include "txt/tdinamic.hpp"
#include "txt/tgeneric.hpp"

#include "int/intestes.hpp"
#include "int/onda.hpp"
#include "int/freccia.hpp"
#include "int/forcella.hpp"
#include "int/legatura.hpp"
#include "int/cambiori.hpp"
#include "int/modifott.hpp"
#include "int/legatqua.hpp"
#include "int/legatval.hpp"
#include "int/pedalefinoa.hpp"
#include "int/trilloonda.hpp"
#include "int/bend.hpp"
#include "int/raggruppamento.hpp"	//FFF

#include "sca/numbatt.hpp"
#include "sca/numgrand.hpp"
#include "sca/numpausa.hpp"
#include "sca/lettera.hpp"
#include "sca/tsalto.hpp"
#include "sca/metronom.hpp"
#include "sca/scansion.hpp"
#include "sca/moviment.hpp"
#include "sca/numugual.hpp"
#include "sca/tmovimen.hpp"

#include "str/strument.hpp"
#include "str/violino.hpp"
#include "str/corda.hpp"
#include "str/arco.hpp"
#include "str/arcogiu.hpp"
#include "str/arcosu.hpp"
#include "str/direzarc.hpp"
#include "str/posizarc.hpp"
#include "str/partearc.hpp"
#include "str/pizzicat.hpp"
#include "str/ponticel.hpp"
#include "str/tastiera.hpp"
#include "str/punta.hpp"
#include "str/tallone.hpp"
#include "str/timpano.hpp"
#include "str/ditacord.hpp"

#include "abb/tremolo.hpp"
#include "abb/glissato.hpp"
#include "abb/gslash.hpp"
#include "abb/gup.hpp"

#include "kor/slidingup.hpp"
#include "kor/slidingdown.hpp"
#include "kor/slidingdup.hpp"
#include "kor/slidingdownup.hpp"
#include "kor/nonghyninc.hpp"
#include "kor/nonghyndec.hpp"
#include "kor/nonghynarrow.hpp"
#include "kor/nonghynwide.hpp"
