#include <wx/wx.h>
#include <ctype.h>

#include "saveheaderxml.hpp"
#include "lioo.hpp"

#include "smr/smritem.hpp"

#ifndef WX226
using namespace std;
#endif

int Mkdir(char* path,int);

extern wxString XMLFormatString(const wxString& s);

Save::Save()
{
}

Save::~Save()
{
}

void Save::Naviga(SMRFile* smrf)
{
	SMRItemList::Node *nodo;
	wxString fileName;

	SMRItemList& Lista=smrf->GetItemsList();
	nodo=Lista.GetFirst();
	if (nodo)
	{
		Mkdir((char*)(smrf->GetPath()).c_str(),0);
		fileName=smrf->GetPath()+PATH_SEP+smrf->GetFilename();
		
		xml.open(fileName);
		if(!xml)
		{
			//cout << "Cannot open Identification.xml file.\n";
			return;
		}
		xml << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" << endl;
		//xml << "<!DOCTYPE wdfheader SYSTEM \"wdfheader.dtd\">" << endl;
		xml << "<wdfheader WDF_CONDITION=\"FULL\">" << endl;
		XMLIdentification(nodo);
		XMLClassification(nodo);
		if(!smrf->IsFromMIDI())
			XMLSymbolic(nodo,smrf);
		XMLSymbolicMilla(nodo);
		XMLSymbolicFonts(nodo);
		XMLPerformance(nodo);
		if(!smrf->IsFromMIDI())
			XMLLyric(nodo);
		XMLAudio(nodo);
		xml << "</wdfheader>";
		xml.close();
	}
}

void Save::XMLIdentification(SMRItemList::Node *nodoIdent)
{
/*
	WDFTreeItemData *corrente;
	WDFIdentificationR *ident;
	bool FlagIden;

	FlagIden=true;
	while ((nodoIdent) && FlagIden)
	{
		corrente=nodoIdent->GetData();
		ident=(WDFIdentificationR*)corrente;
		if (corrente->GetType() == WDF_Identification)
		{
			FlagIden= false;
			xml << "\t<Identification";
			if(!ident->GetIsVisible())
				xml << " HIDDEN=\"TRUE\">" << endl;
			else
				xml << ">" << endl;
			xml << "\t\t<WDFID>" << ident->GetWDFid().GetPublisherIDcode() << ident->GetWDFid().GetObjectIDnumber() << "</WDFID>" << endl;
			switch (ident->GetISxx1().GetType())
			{
			case 0:
				xml << "\t\t<ISxx TYPE=\"ISBN\" CODE=\"" << XMLFormatString(ident->GetISxx1().GetCode()) << "\"/>" << endl;
				break;
			case 1:
				xml << "\t\t<ISxx TYPE=\"ISMN\" CODE=\"" << XMLFormatString(ident->GetISxx1().GetCode()) << "\"/>" << endl;
				break;
			case 2:
				xml << "\t\t<ISxx TYPE=\"ISRC\" CODE=\"" << XMLFormatString(ident->GetISxx1().GetCode()) << "\"/>" << endl;
				break;
			}
			switch (ident->GetISxx2().GetType())
			{
			case 0:
				xml << "\t\t<ISxx TYPE=\"ISBN\" CODE=\"" << XMLFormatString(ident->GetISxx2().GetCode()) << "\"/>" << endl;
				break;
			case 1:
				xml << "\t\t<ISxx TYPE=\"ISMN\" CODE=\"" << XMLFormatString(ident->GetISxx2().GetCode()) << "\"/>" << endl;
				break;
			case 2:
				xml << "\t\t<ISxx TYPE=\"ISRC\" CODE=\"" << XMLFormatString(ident->GetISxx2().GetCode()) << "\"/>" << endl;
				break;
			}
			switch (ident->GetISxx3().GetType())
			{
			case 0:
				xml << "\t\t<ISxx TYPE=\"ISBN\" CODE=\"" << XMLFormatString(ident->GetISxx3().GetCode()) << "\"/>" << endl;
				break;
			case 1:
				xml << "\t\t<ISxx TYPE=\"ISMN\" CODE=\"" << XMLFormatString(ident->GetISxx3().GetCode()) << "\"/>" << endl;
				break;
			case 2:
				xml << "\t\t<ISxx TYPE=\"ISRC\" CODE=\"" << XMLFormatString(ident->GetISxx3().GetCode()) << "\"/>" << endl;
				break;
			}
			xml << "\t\t<Publisher PUBLISHING_STATUS=\"";
			switch (ident->GetPublishingStatus())
			{
			case 0:
				xml << "PUBLISHED";
				break;
			case 1:
				xml << "UNPUBLISHED";
				break;
			case 2:
				xml << "MASTER";
				break;
			case 3:
				xml << "INTERNET";
			default:
				xml << "OTHER";
			}
			xml << "\"";
				if (ident->GetLocationPublishing() != "")
			xml << " PUBLISHING_LOCATION=\"" << XMLFormatString(ident->GetLocationPublishing()) << "\"";
			xml << ">" << XMLFormatString(ident->GetPublisher()) << "</Publisher>" << endl;
			xml << "\t\t<Preparation_date MAJOR_VERSION=\"" << ident->GetVersionMajor() << "\"";
			xml << " MINOR_VERSION=\"" << ident->GetVersionMinor() << "\">";
			xml << DateToYYYYMMDD(ident->GetDateOfPreparation()) << "</Preparation_date>" << endl;
			xml << "\t\t<Music_Geographic_Area>" << XMLFormatString(ident->GetMusicGeographicArea()) << "</Music_Geographic_Area>" << endl;
			if (ident->GetCatalogueIdentification() != "")
				xml << "\t\t<Catalog_ID>" << XMLFormatString(ident->GetCatalogueIdentification()) << "</Catalog_ID>" << endl;
			if (ident->GetSecondPublisher() != "")
				xml << "\t\t<Second_publisher>" << XMLFormatString(ident->GetSecondPublisher()) << "</Second_publisher>" << endl;
			if (ident->GetLocalDistributorID() != "")
			{
				xml << "\t\t<LocalDistributor>" << endl;
				xml << "\t\t\t<LD_ID>" << XMLFormatString(ident->GetLocalDistributorID()) << "</LD_ID>" << endl;
				xml << "\t\t\t<LD_NAME>" << XMLFormatString(ident->GetLocalDistributorName()) << "</LD_NAME>" << endl;
				xml << "\t\t</LocalDistributor>" << endl;
			}
			if (ident->GetServerURL() != "")
				xml << "\t\t<URI>" << XMLFormatString(ident->GetServerURL()) << "</URI>" << endl;
			if (ident->GetResponsibleName() != "")
				xml << "\t\t<Responsible_Name>" << XMLFormatString(ident->GetResponsibleName()) << "</Responsible_Name>" << endl;
			if (ident->GetQualityLevel() != 0)
				xml << "\t\t<Quality_Level>" << ident->GetQualityLevel() << "</Quality_Level>" << endl;
			xml << "\t</Identification>" << endl;
		}
		nodoIdent=nodoIdent->GetNext();
	}
*/
	}

void Save::XMLClassification(SMRItemList::Node *nodoClassi)
{
/*
	WDFTreeItemData *corrente;
	WDFClassificationR *classi;
	bool FlagClassi;
	
	FlagClassi=true;
	while (nodoClassi)
	{
		corrente=nodoClassi->GetData();
		classi=(WDFClassificationR*)corrente;
		if (corrente->GetType() == WDF_Classification)
		{
			FlagClassi=false;
			xml << "\t<Classification xml:lang=\"" << XMLFormatString(classi->GetLanguageOfThisClassification()) << "\"";
			xml << " Description=\"" << XMLFormatString(classi->GetItemDescription()) << "\"";
			if(!classi->GetIsVisible())
				xml << " HIDDEN=\"TRUE\">" << endl;
			else
				xml << ">" << endl;
			if (classi->GetReviewer() != "")
			{
				xml << "\t\t<Criticalreview REVIEWER=\"" << XMLFormatString(classi->GetReviewer()) << "\"";
				if (!classi->GetDateOfReview().IsNull())
					xml << " DATE=\"" << DateToYYYYMMDD(classi->GetDateOfReview()) << "\"";
				xml << ">" << endl;
				xml << "\t\t\t<Review_Description>" << XMLFormatString(classi->GetCriticalReview()) << "</Review_Description>" << endl; 
				xml << "\t\t</Criticalreview>" << endl; 
			}
			if (classi->GetATextualDescription() != "")
				xml << "\t\t<Textual_description>" << XMLFormatString(classi->GetATextualDescription()) << "</Textual_description>" << endl;
			if (classi->GetInstrument() != "")
			{	
				xml << "\t\t<Instrument";
				switch (classi->GetInstrumentTonality())
				{
				case 0:
					xml << " TONALITY=\"A\"";
					break;
				case 1:
					xml << " TONALITY=\"B\"";
					break;
				case 2:
					xml << " TONALITY=\"C\"";
					break;
				case 3:
					xml << " TONALITY=\"G\"";
					break;
				}
				xml << ">" << XMLFormatString(classi->GetInstrument()) << "</Instrument>" << endl;
			}
			if (classi->GetPieceTonality() != "")
				xml << "\t\t<Piece_tonality>" << XMLFormatString(classi->GetPieceTonality()) << "</Piece_tonality>" << endl;
			if (classi->GetAuthor() != "")
				xml << "\t\t<Author>" << XMLFormatString(classi->GetAuthor()) << "</Author>" << endl;
			xml << "\t\t<Unique_Short_Name>" << XMLFormatString(classi->GetUniqueShortName()) << "</Unique_Short_Name>" << endl;
			xml << "\t\t<Title>" << XMLFormatString(classi->GetTitle()) << "</Title>" << endl;
			if (classi->GetParallelTitle() != "")
				xml << "\t\t<Parallel_Title>" << XMLFormatString(classi->GetParallelTitle()) << "</Parallel_Title>" << endl;
			if (classi->GetAct() != "")
				xml << "\t\t<Act>" << XMLFormatString(classi->GetAct()) << "</Act>" << endl;
			if (classi->GetMovement() != "")
				xml << "\t\t<Movement>" << XMLFormatString(classi->GetMovement()) << "</Movement>" << endl;
			if (classi->GetPieceTypeOrEnsemble() != "")
				xml << "\t\t<Ensemble>" << XMLFormatString(classi->GetPieceTypeOrEnsemble()) << "</Ensemble>" << endl;
			xml << "\t\t<Genre>" << XMLFormatString(classi->GetGenre()) << "</Genre>" << endl;
			xml << "\t\t<Style>" << XMLFormatString(classi->GetStyle()) << "</Style>" << endl;
			if (classi->GetPurpose() != "")
				xml << "\t\t<Purpose>" << XMLFormatString(classi->GetPurpose()) << "</Purpose>" << endl;
			if (classi->GetExtractedFrom() != "")
				xml << "\t\t<Extracted_from>" << XMLFormatString(classi->GetExtractedFrom()) <<"</Extracted_from>"  << endl;
			if (classi->GetASequenceNumber() != "")
				xml << "\t\t<Sequence_Number>" << XMLFormatString(classi->GetASequenceNumber()) << "</Sequence_Number>" << endl;
			if (classi->GetAlphanumericNumbering() != "")
				xml << "\t\t<Alphanumeric_number>" << XMLFormatString(classi->GetAlphanumericNumbering()) << "</Alphanumeric_number>" << endl;
			xml << "\t\t<Original_language>" << XMLFormatString(classi->GetOriginalLanguage()) << "</Original_language>" << endl;
			if (classi->GetDuration() != 0)
				xml << "\t\t<Duration>" << classi->GetDuration() << "</Duration>" << endl;
			xml << "\t\t<Composition_date>" << DateToYYYYMMDD(classi->GetDateOfComposition()) << "</Composition_date>" << endl;
			xml << "\t\t<Epoque>" << endl;
			xml << "\t\t\t<Start_year>" << classi->GetEpoch().GetYear1() << "</Start_year>" << endl;
			xml << "\t\t\t<End_year>" << classi->GetEpoch().GetYear2() << "</End_year>" << endl;
			xml << "\t\t</Epoque>" << endl;
			if (classi->GetLocationOfComposition() != "")
				xml << "\t\t<Composition_location>" << XMLFormatString(classi->GetLocationOfComposition()) << "</Composition_location>" << endl;
			if (classi->GetNationality() != "")
				xml << "\t\t<Nationality>" << XMLFormatString(classi->GetNationality()) << "</Nationality>" << endl;
			if (classi->GetDedicatedTo() != "")
				xml << "\t\t<Dedicated_to>" << XMLFormatString(classi->GetDedicatedTo()) << "</Dedicated_to>" << endl;
			if (classi->GetCommitment() != "")
				xml << "\t\t<Commitment>" << XMLFormatString(classi->GetCommitment()) << "</Commitment>" << endl;
			if (classi->GetFirstExecution() != "")
				xml << "\t\t<First_execution>" << XMLFormatString(classi->GetFirstExecution()) << "</First_execution>" << endl;
			if (classi->GetPerformerList()->GetCount()>0)
			{
				xml << "\t\t<Performers>" << endl;
				for ( PerformerLIST::Node *node = classi->GetPerformerList()->GetFirst(); node; node = node->GetNext() )
				{
					Performer *current = node->GetData();
					
					xml << "\t\t\t<Performer ROLE=\"" << XMLFormatString(current->GetRole()) << "\">" << XMLFormatString(current->GetName()) << "</Performer>" << endl;
				}
				xml << "\t\t</Performers>" << endl;
			}
			xml << "\t</Classification>" << endl;
		}
		nodoClassi=nodoClassi->GetNext();
	}
	if (FlagClassi==true)
	{
		xml << "\t<Classification xml:lang=\"\" Description=\"\">" << endl;
		xml << "\t\t<Unique_Short_Name>-</Unique_Short_Name>" << endl;
		xml << "\t\t<Title>-</Title>" << endl;
		xml << "\t\t<Genre>-</Genre>" << endl;
		xml << "\t\t<Style>-</Style>" << endl;
		xml << "\t\t<Original_language>-</Original_language>" << endl;
		xml << "\t\t<Composition_date>00000000</Composition_date>" << endl;
		xml << "\t\t<Epoque>" << endl;
		xml << "\t\t\t<Start_year>0</Start_year>" << endl;
		xml << "\t\t\t<End_year>0</End_year>" << endl;
		xml << "\t\t</Epoque>" << endl;
		xml << "\t</Classification>" << endl;
	}
*/
}

void Save::SaveSMRItem(SMRItem *item)
{
	xml << "\t\t<Wdfitem>" << endl;

	xml << "\t\t\t<Filename>" << XMLFormatString(item->GetFilename()) << "</Filename>" << endl;
	if(item->GetID()!="")
		xml << "\t\t\t<WDFCID>" << item->GetID().c_str() << "</WDFCID>" << endl;
	xml << "\t\t\t<Textual_description>" << XMLFormatString(item->GetItemDescription()) << "</Textual_description>" << endl;  
	xml << "\t\t</Wdfitem>" << endl;
}

void Save::XMLSymbolic(SMRItemList::Node *nodoSymbolic,SMRFile* smrf)
{
	SMRItem *corrente;
	bool isFirst=true;
	int s=1;

	while (nodoSymbolic)
	{
		corrente=nodoSymbolic->GetData();
		if (corrente->GetType() == SMR_MainScore || corrente->GetType()==SMR_Part)
		{
			if(isFirst)
			{
				xml << "\t<Symbolic>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
			if(corrente->GetType()==SMR_MainScore)
				static_cast<SMRMainScoreItem*>(corrente)->SaveXML();
			else
				static_cast<SMRPartItem*>(corrente)->SaveXML(s++);
		}
		nodoSymbolic=nodoSymbolic->GetNext();
	}
	if(!isFirst)
		xml << "\t</Symbolic>"<<endl;
}

void Save::XMLSymbolicMilla(SMRItemList::Node *nodoSymbolic)
{
	SMRItem *corrente;
	bool isFirst=true;

	while (nodoSymbolic)
	{
		corrente=nodoSymbolic->GetData();
		if (corrente->GetType() == SMR_SMFL)
		{
			if(isFirst)
			{
				xml << "\t<Symbolic_Milla>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
		}
		nodoSymbolic=nodoSymbolic->GetNext();
	}
	if(!isFirst)
		xml << "\t</Symbolic_Milla>"<<endl;
}

void Save::XMLSymbolicFonts(SMRItemList::Node *nodoSymbolic)
{
	SMRItem *corrente;
	bool isFirst=true;

	while (nodoSymbolic)
	{
		corrente=nodoSymbolic->GetData();
		if (corrente->GetType() == SMR_Font)
		{
			if(isFirst)
			{
				xml << "\t<Symbolic_Fonts>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
		}
		nodoSymbolic=nodoSymbolic->GetNext();
	}
	if(!isFirst)
		xml << "\t</Symbolic_Fonts>"<<endl;
}

void Save::XMLPerformance(SMRItemList::Node *nodoPerformance)
{
	SMRItem *corrente;
	bool isFirst=true;

	while (nodoPerformance)
	{
		corrente=nodoPerformance->GetData();
		if (corrente->GetType() == SMR_SynchInfo)
		{
			if(isFirst)
			{
				xml << "\t<Performance>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
		}
		nodoPerformance=nodoPerformance->GetNext();
	}
	if(!isFirst)
		xml << "\t</Performance>"<<endl;
}
void Save::XMLLyric(SMRItemList::Node *nodoLyric)
{
	SMRItem *corrente;
	bool isFirst=true;

	while (nodoLyric)
	{
		corrente=nodoLyric->GetData();
		if (corrente->GetType() == SMR_Lyrics)
		{
			if(isFirst)
			{
				xml << "\t<Lyric>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
		}
		nodoLyric=nodoLyric->GetNext();
	}
	if(!isFirst)
		xml << "\t</Lyric>"<<endl;
}

void Save::XMLAudio(SMRItemList::Node *nodoLyric)
{
	SMRItem *corrente;
	bool isFirst=true;

	while (nodoLyric)
	{
		corrente=nodoLyric->GetData();
		if (corrente->GetType() == SMR_Audio)
		{
			if(isFirst)
			{
				xml << "\t<Audio>" << endl;
				isFirst=false;
			}
			SaveSMRItem(corrente);
		}
		nodoLyric=nodoLyric->GetNext();
	}
	if(!isFirst)
		xml << "\t</Audio>"<<endl;
}