
#ifdef WX226
#include <iostream.h>
#include <fstream.h>
#else
#include <iostream>
#include <fstream>
using std::ostream;
using std::ofstream;
#endif

#include "../../smr/smr.hpp"
#include "savecomponentxml.hpp"

class Save
{
	protected:
		ofstream xml;

		void XMLIdentification(SMRItemList::Node *nodo);
		void XMLClassification(SMRItemList::Node *nodo);
		void XMLSymbolic(SMRItemList::Node *nodo,SMRFile* smrf);
		void XMLSymbolicMilla(SMRItemList::Node *nodo);
		void XMLSymbolicFonts(SMRItemList::Node *nodo);
		void XMLPerformance(SMRItemList::Node *nodo);
		void XMLLyric(SMRItemList::Node *nodo);
		void XMLAudio(SMRItemList::Node *nodo);
		void SaveSMRItem(SMRItem* item);
	public:
		Save();
		virtual ~Save();
		void Naviga(SMRFile* smrf);
};
