/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#define NUM_MAXLEN 256
#define DESCRIPTION_MAXLEN 256

const char ELSWF_Main[]="SMXF_Main";
const char ELWDFCID[]="WDFCID";
const char ELIdentification[]="Identification";
const char ELWDFID[]="WDFID";
const char ELPublisher[]="Publisher";
const char ATPUBLISHING_STATUS[]="PUBLISHING_STATUS";
const char ELPreparation_date[]="Preparation_date";
const char ATMAJOR_VERSION[]="MAJOR_VERSION";
const char ATMINOR_VERSION[]="MINOR_VERSION";
const char ELMusic_Geographic_Area[]="Music_Geographic_Area";
const char ELClassification[]="Classification";
const char ATxmllang[]="xml:lang";
const char ATDescription[]="Description";
const char ELUnique_Short_Name[]="Unique_Short_Name";
const char ELTitle[]="Title";
const char ELGenre[]="Genre";
const char ELStyle[]="Style";
const char ELOriginal_language[]="Original_language";
const char ELComposition_date[]="Composition_date";
const char ELEpoque[]="Epoque";
const char ELStart_year[]="Start_year";
const char ELEnd_year[]="End_year";
const char ELWatermark[]="Watermark";
const char ELWMCode[]="WM.Code";
const char ELWMAlgorithm[]="WM.Algorithm";
const char ELFont_FON[]="Font_FON";
const char ELFont_PS[]="Font_PS";
const char ELFont_Table[]="Font_Table";
const char ELBracket[]="Bracket";
const char ATTYPE[]="TYPE";
const char ELBracketstart[]="Bracket.start";
const char ELBracketend[]="Bracket.end";
const char ELSWF_Part[]="SMXF_Part";
const char ELSymbolic[]="Symbolic";
const char ELmainscore[]="mainscore";
const char ATFROM[]="FROM";
const char ELformatpageview[]="formatpageview";
const char ELstrumesec[]="strumesec";
const char ELmeasure[]="measure";
const char ATPROGRESSIVE[]="PROGRESSIVE";
const char ATMEASUREID[]="MEASUREID";
const char ATPARTPAGE[]="PARTPAGE";
const char ATARCPAGE[]="ARCPAGE";
const char ATDIRECTORPAGE[]="DIRECTORPAGE";
const char ATBAR[]="BAR";
const char ELmeasurejustification[]="measure.justification";
const char ELcomputermj[]="computer.mj";
const char ELmainmj[]="main.mj";
const char ATFACTOR[]="FACTOR";
const char ELspacetofirstfigure[]="space.to.first.figure";
const char ELuserspacetofirstfigure[]="user.space.to.first.figure";
const char ELpartmj[]="part.mj";
const char ELintestazione[]="intestazione";
const char ELlayer[]="layer";
const char ATNUMBER[]="NUMBER";
const char ELfigure[]="figure";
const char ATNUMERICCODE[]="NUMERICCODE";
