#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define yyparse milparse
#define yylex millex
#define yyerror milerror
#define yychar milchar
#define yyval milval
#define yylval millval
#define yydebug mildebug
#define yynerrs milnerrs
#define yyerrflag milerrflag
#define yyss milss
#define yyssp milssp
#define yyvs milvs
#define yyvsp milvsp
#define yylhs millhs
#define yylen millen
#define yydefred mildefred
#define yydgoto mildgoto
#define yysindex milsindex
#define yyrindex milrindex
#define yygindex milgindex
#define yytable miltable
#define yycheck milcheck
#define yyname milname
#define yyrule milrule
#define YYPREFIX "mil"
#line 10 "./mil/lgiust.y"

#define YYSTACKSIZE 1500

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdarg.h>

#include "mil/lgiust.h"
#include "mil/immissione.hpp"
#include "mil/posiz.hpp"
#include "mil/priorita.hpp"
#include "mil/simboli.hpp"

int millex(void);
int milparse(void);

extern char *getenv(const char *);
void Errore(char * comm, char * nom, int num);
          
/* Variabili di lgiust.l */
#define MIL_CHAR char

extern MIL_CHAR *miltext;
extern int MilCompareId(const void * Element1, const void * Element2);
extern KEYWORDMIL MilKeywords[];
extern MilKeywordNumber;
extern ITEMPOS CurrentItemPos;
extern ITEMIMM CurrentItemImm;
extern CONDITIONIMM CurrentConditionImm;
extern CONDITIONPOS CurrentConditionPos;
extern ITEMPOS ItemListPos[];
extern ITEMPOS ItemListPos[];
extern CONDITIONIMM ConditionListImm[];
extern CONDITIONPOS ConditionListPos[];
extern PITEMPOS CurrentRulePos;
extern PITEMIMM CurrentRuleImm;
extern PCONDITIONIMM CurrentCondImm;
extern PCONDITIONPOS CurrentCondPos;
extern RANGE CurrentRange;
extern int CurrentConditionImmUsage;
extern int CurrentConditionPosUsage;

extern FILE *milin;
extern int mil_init;
extern struct mil_buffer_state* mil_scan_string(const char*);
extern void Restart();

extern int lasttoken;
extern int token;
extern int inruleimm;
extern int inrulepos;
extern int incondimm;
extern int incondpos;
extern int CurrentColImm;
extern int CurrentColPos;

Immissione* pimm;
Posiz* ppos;
Priorita* ppri;
Simboli* psym;

int millineno;
int milloadError;    
 
#define YYSTACKSIZE 1500 
   
#line 80 "./mil/lgiust.y"
typedef union {
     double real;
     int integer;
     char *string;
} YYSTYPE;
#line 111 "./mil/m.tab.cpp"
#define INTEGER 257
#define RELNOTA 258
#define RELPAUSA 259
#define RELSTAFF 260
#define RELNOTES 261
#define DEFAULTX 262
#define ALTERNATIVE 263
#define ONLEFT 264
#define ONRIGHT 265
#define BELOW 266
#define ABOVE 267
#define STEMUP 268
#define STEMDOWN 269
#define BEAM12 270
#define BEAM23 271
#define INMULTISTAFF 272
#define ONSTAFFNUMBER 273
#define STAFFNUMBER 274
#define STAFFLINES 275
#define SAMESTEMONLEFT 276
#define SAMESTEMONRIGHT 277
#define AVOIDINSTAFF 278
#define OUTSIDESTAFF 279
#define ANYWHERE 280
#define ONSPACE 281
#define ONLINE 282
#define ONSTAFF 283
#define DOWNWARDS 284
#define UPWARDS 285
#define PAUSA 286
#define THEN 287
#define immIF 288
#define posIF 289
#define INMULTIVOICEUPPER 290
#define INMULTIVOICELOWER 291
#define INENDBATTUTA 292
#define INBEAM 293
#define INTUPLET 294
#define INPUNTOVALORE 295
#define INCHORDSUSPENDED 296
#define INSTACCATO 297
#define INLEGVALORE 298
#define NOT 299
#define NOTE 300
#define NEARNOTA 301
#define NEARNOTES 302
#define INCHORD 303
#define INMULTIVOICE 304
#define OPPOSITETOSTEM 305
#define ONSTEM 306
#define SUSPENDED 307
#define UPPER 308
#define LOWER 309
#define INTERMEDIATE 310
#define CAMBIOCHIAVE 311
#define AND 312
#define OR 313
#define XOR 314
#define APP 315
#define ACC 316
#define GRUP 317
#define MORD 318
#define TRILLO 319
#define TREM 320
#define ARP 321
#define GLISS 322
#define DIESIS 323
#define BEMOL 324
#define DOPDIES 325
#define DOPBEMOL 326
#define MONES 327
#define TRIES 328
#define LEG 329
#define STAC 330
#define IDENTIFIER 331
#define SFOR 332
#define ACCE 333
#define MARTF 334
#define TEN 335
#define MART 336
#define PUNTOALL 337
#define LEGVAL 338
#define PUNTOVAL 339
#define CORONA 340
#define LEFTPAR 341
#define RIGHTPAR 342
#define LEFTPARQ 343
#define RIGHTPARQ 344
#define REAL 345
#define EQUAL 346
#define COMMA 347
#define MAGGIORE 348
#define MINORE 349
#define STRING 350
#define SEMICOLON 351
#define SCALE 352
#define RULE_NAME 353
#define RULEPOS 354
#define RULEIMM 355
#define ANGLE 356
#define STEM 357
#define PSEMIBREVE 358
#define PMINIMA 359
#define PSEMIMINIMA 360
#define PCROMA 361
#define PSEMICROMA 362
#define PBISCROMA 363
#define PSEMIBISCROMA 364
#define DELTAX 365
#define DELTAY 366
#define UPPERDIST 367
#define LOWERDIST 368
#define NUMDOWN 369
#define NUMUP 370
#define VAR 371
#define LENGHT 372
#define WITH 373
#define BEAM 374
#define INCHORDTRE 375
#define ALTERAZIONE 376
#define INCHORDSETTIMA 377
#define INCHORDminSETTIMA 378
#define INCHORDSUSPINTERM 379
#define INCHORDSUSPUPPER 380
#define INCHORDSUSPLOWER 381
#define ARCATA 382
#define PIZZICATO 383
#define CORDA 384
#define ARCATASU 385
#define ARCATAGIU 386
#define PUNTA 387
#define TALLONE 388
#define PONTICELLO 389
#define TASTIERA 390
#define ARCO 391
#define OTTAVA 392
#define INOTTAVASOPRA 393
#define INOTTAVASOTTO 394
#define INTWOSTAFF 395
#define INSINGLELAYER 396
#define NOTAWITH 397
#define NOTES 398
#define BISCROMA 399
#define SEMIBISCROMA 400
#define FUSA 401
#define CROMA 402
#define SEMICROMA 403
#define SEMIMINIMA 404
#define MINIMA 405
#define SEMIBREVE 406
#define BREVE 407
#define NOTINA 408
#define RULEPRI 409
#define STEMHEIGHT 410
#define MOBEMOL 411
#define TRIBEMOL 412
#define FIRSTUPPER 413
#define FIRSTLOWER 414
#define PRECEED 415
#define NBEAT 416
#define TIME 417
#define BATTUTA 418
#define COPPIE 419
#define OFF 420
#define ON 421
#define GTinBEAT 422
#define GREATER 423
#define LOWer 424
#define LOWERe 425
#define GREATERe 426
#define UPPERD 427
#define LOWERD 428
#define MEAN 429
#define DELTA 430
#define BEAMDIS 431
#define MHL 432
#define PLUS 433
#define MIN 434
#define DEFGROUP 435
#define DEFSYM 436
#define GROUP 437
#define CODE 438
#define DIM 439
#define CONSORD 440
#define VIASORD 441
#define ARM 442
#define DITEG 443
#define HEAD 444
#define CLASSIC 445
#define ALPHANUM 446
#define ALPHANUM_SQUARE 447
#define ALPHANUM_REVERSE 448
#define CIRCLEX 449
#define CLUSTER 450
#define X_HEAD 451
#define CROIX 452
#define DDIESIS 453
#define DIAMOND 454
#define TRIANG 455
#define TRIANG_UP 456
#define TRIANG_DOWN 457
#define TRIANG_LEFT 458
#define TRIANG_RIGHT 459
#define TRIANG_ROUND 460
#define MOON 461
#define PLUS_HEAD 462
#define RHYTHMIC 463
#define SQUARE 464
#define STEMSTART 465
#define YYERRCODE 256
short millhs[] = {                                        -1,
    0,    0,   10,   10,   10,   10,   10,   10,    9,   16,
   18,   15,   19,   17,   20,   20,   12,   12,   21,   21,
   21,   22,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,   28,   28,   28,   28,
   28,   28,   28,   28,   29,   29,   29,   29,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   31,   31,   31,
   31,   31,   31,   31,   31,   32,   32,   32,   33,   33,
   33,   33,   33,   33,   33,   34,   34,   34,   34,   34,
   34,   34,   34,   34,   34,   23,   23,   23,   23,   24,
   24,   24,   24,   24,   24,   24,   24,   39,   39,   35,
   35,   36,   36,   37,   37,   37,   37,   25,   25,   25,
   25,   25,   25,   25,   25,   38,   38,   40,   40,   40,
   40,   40,   41,   42,   42,   43,   26,   26,   26,   44,
   44,   44,   44,   45,   45,   45,   45,    1,    1,    1,
   27,   46,   46,   48,   48,   48,   47,   47,   51,   51,
   49,   49,   50,   50,   50,   11,   11,   52,   52,   52,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    6,    6,    7,    7,    7,
    7,    7,    4,    3,    3,    3,    3,    3,    3,    3,
   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
   55,   55,   55,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   54,   54,   54,   13,   56,   14,
   59,   59,   60,   60,   60,   60,   60,   60,   60,   60,
   60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
   60,   60,   60,   60,   60,   60,   60,   60,   60,
};
short millen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    2,    2,
    0,    6,    3,    3,    0,   13,    4,    4,    0,    1,
    1,    6,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    3,    3,    3,
    3,    3,    3,    3,    3,    5,    0,    2,    1,    3,
    3,    3,    3,    3,    3,    3,    3,    1,    1,    1,
    5,    0,    3,    0,    3,    3,    0,    1,    1,    1,
    0,   11,    0,    3,    3,    4,    4,    1,    3,    2,
    2,    2,    3,    2,    2,    1,    1,    1,    2,    3,
    5,    5,    3,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    3,    1,    2,
    0,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
short mildefred[] = {                                      0,
    0,    0,  269,    0,    0,    0,    0,    0,    0,    0,
    0,    3,    4,    5,    6,    7,    8,    0,  245,  204,
  203,  205,  216,  236,  237,  238,    0,  214,  217,  220,
  234,  235,  100,  101,   37,   38,   39,   40,   41,   42,
   43,   44,   49,   50,   51,   52,   53,   54,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   68,    0,
   23,    0,    0,   71,   72,   73,   74,   75,  198,  197,
   26,   55,  240,  241,   76,   77,   78,   79,   80,   81,
   82,   83,   84,   85,   27,  242,  243,  244,  239,    0,
  215,   56,   57,  213,   28,  195,  196,  199,  200,  201,
  202,   45,   46,   47,   48,    0,   25,    0,    0,    0,
    0,   29,   30,   31,   32,   33,   34,   35,  168,    0,
    0,  166,  167,    0,    0,    0,  281,  282,  283,  275,
  273,  276,  277,  278,  274,  279,  280,  294,  299,  284,
  286,  287,  288,  289,  290,  291,  292,  293,  285,  297,
  298,  296,  295,  270,    0,   10,   11,    2,    9,    0,
  160,   36,   69,   70,   24,  164,  175,  176,  177,  178,
  179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  174,  149,  150,    0,
    0,  162,   98,   99,  102,  103,  104,  105,  106,  107,
  116,  117,  224,  225,  226,  227,  232,  233,  248,  249,
  250,  251,  252,    0,  228,  229,  230,  231,  253,  254,
  255,  256,  257,  260,  261,  262,  263,  264,  258,  259,
  247,  246,  222,  223,  165,  161,  221,  169,    0,  212,
  208,  209,  211,  210,  206,  207,    0,    0,    0,  265,
  266,  267,    0,    0,   20,   21,    0,    0,  272,    0,
  268,  163,  170,  139,  138,  140,    0,    0,    0,  173,
  156,  159,  157,    0,   18,   17,    0,    0,    0,    0,
    0,   86,   87,   88,   89,    0,    0,    0,    0,    0,
  171,  172,   96,   97,    0,   91,   92,   93,   94,   95,
   14,    0,    0,   12,  126,  109,  110,  111,  112,    0,
    0,    0,    0,  113,  114,  115,   13,    0,    0,    0,
    0,    0,    0,    0,    0,  129,    0,  119,  118,  120,
  122,  121,  125,  124,  123,    0,    0,    0,   22,    0,
  128,    0,  131,  130,  132,  133,  135,  134,  136,  137,
    0,    0,  148,    0,  143,    0,    0,    0,    0,    0,
    0,    0,  145,  146,    0,    0,  141,    0,    0,    0,
    0,    0,  154,  155,    0,    0,    0,    0,    0,    0,
   16,    0,    0,    0,  152,
};
short mildgoto[] = {                                       9,
  267,  108,  109,  110,  111,  247,  248,  187,   10,   11,
   12,   13,   14,   15,   16,   17,  278,  260,  289,  304,
  257,  275,  286,  295,  313,  324,  339,  112,  113,  114,
  115,  116,  117,  118,  119,  231,  232,  233,  234,  314,
  315,  316,  235,  325,  326,  340,  352,  357,  361,  367,
  192,  120,  121,  253,  236,  122,  123,  238,  154,  155,
};
short milsindex[] = {                                   -269,
 -268, -268,    0, -352, -345,  698, -329, -321,    0, -269,
 -312,    0,    0,    0,    0,    0,    0, -272,    0,    0,
    0,    0,    0,    0,    0,    0,  -92,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  399,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  165,    0, -274,  697, -267,
   50,    0,    0,    0,    0,    0,    0,    0,    0, -199,
 -286,    0,    0, -189, -218, -218,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  698,    0,    0,    0,    0, -268,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  399,
  399,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -194,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -194,    0,
    0,    0,    0,    0,    0,    0,  -53, -245, -246,    0,
    0,    0, -268, -241,    0,    0,  399,  399,    0, -299,
    0,    0,    0,    0,    0,    0, -209, -204, -271,    0,
    0,    0,    0, -127,    0,    0, -198, -270, -194, -194,
 -176,    0,    0,    0,    0,  231, -166, -161, -253, -157,
    0,    0,    0,    0, -237,    0,    0,    0,    0,    0,
    0,  -69, -156,    0,    0,    0,    0,    0,    0, -154,
 -151, -150, -229,    0,    0,    0,    0,  -68, -232, -248,
  -55, -143, -142, -147, -160,    0, -132,    0,    0,    0,
    0,    0,    0,    0,    0, -152,   18, -129,    0, -139,
    0,  -39,    0,    0,    0,    0,    0,    0,    0,    0,
 -106, -107,    0,  -97,    0,  -94, -165,   -4, -330,  -91,
 -163,  -86,    0,    0,  -83,  -82,    0,   16, -194, -264,
  -73,  -71,    0,    0,   22, -194,  -67,  -70,   26, -194,
    0,  -58, -194,  -34,    0,
};
short milrindex[] = {                                      0,
    0,    0,    0,    0,    0,  -40,    0,    0,    0,  315,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  120,
    0,  146,  298,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -208,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -273,    0,    0,    0,  533,  533,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -40,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   29,    0,    0,  -33,    0,
    0,    0,    0,    0,  -22,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   47,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -339,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -335,    0,    0,    0,    0, -349,    0,    0,    0,
  -30,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short milgindex[] = {                                    312,
  -23,  -87,    0,    0,   76,    0,   58,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  202,   75,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   59,   61,   70,   72,   79,    0,
    0,    0,    5,    0,   37,    0,    0,    0,    0,    0,
   27,   -2,  339,    0,    0,   30,  259,    0,  214,    0,
};
#define YYTABLESIZE 1141
short miltable[] = {                                     124,
  125,  151,  166,   19,   20,   21,   22,  126,  333,  188,
  189,  147,  214,  158,  363,  144,  147,   23,    1,    2,
  156,   24,   25,   26,  328,  250,  251,  252,  157,   18,
   27,   28,   29,   30,   31,   32,   33,   34,  159,   18,
  306,  307,  308,  255,  256,  309,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,   50,  264,   51,   52,   53,   54,   55,   56,   57,
   58,   59,  151,  160,  240,   24,   24,  158,  239,  147,
    3,   60,  147,  144,    4,    5,  144,  249,   61,   62,
   63,   64,   65,   66,   67,   68,  334,  254,  190,  270,
   69,   70,  262,  263,  343,   71,  271,   72,   73,   74,
  214,  273,  329,   75,   76,   77,   78,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
  282,  283,  284,  285,  310,  322,  323,  277,  330,    6,
  191,  279,   92,   93,  188,  189,  280,  287,   94,   95,
  265,  241,  242,  243,  244,  373,  374,  261,   96,   97,
   98,   99,  100,  101,   24,    7,    8,  288,  292,  274,
  274,  102,  103,  104,  105,  106,  266,  331,  311,   19,
   20,   21,   22,  301,  302,  303,  305,  317,  327,  318,
  214,  319,  344,   23,  320,  321,  107,   24,   25,   26,
  312,  335,  336,  337,  338,  323,   24,   28,   29,   30,
   31,   32,   33,   34,  342,  268,  351,  354,  345,   20,
   21,   22,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45,   46,   47,   48,   49,   50,  355,   51,
   52,   53,   54,   55,   56,   57,   58,   59,  356,  358,
  272,  359,  362,  360,  365,  290,  291,   60,  366,  369,
  368,  108,  108,  370,   61,   62,   63,   64,   65,   66,
   67,   68,  371,  375,  347,  376,   69,   70,  377,  379,
  380,   71,  381,   72,   73,   74,  127,  127,  383,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   90,   90,   90,  385,
  271,   90,   90,   90,    1,   69,   70,   15,   92,   93,
  153,  158,  269,  332,   94,   95,  281,  258,  108,  108,
  142,  142,  276,  108,   96,   97,   98,   99,  100,  101,
  346,  350,  108,  108,  296,  372,  297,  102,  103,  104,
  105,  106,  378,  127,  127,  298,  382,  299,  127,  384,
  214,  341,  348,  364,  300,  161,  353,  237,  259,    0,
    0,    0,  107,   96,   97,   98,   99,  100,  101,   90,
   90,    0,    0,    0,   90,    0,    0,    0,  349,    0,
    0,    0,    0,   90,   90,  240,  108,  142,    0,  108,
   90,    0,  142,   36,   36,    0,  269,    0,    0,  218,
  218,  218,  218,  218,  218,  218,  218,  218,    0,    0,
    0,  127,    0,    0,  127,    0,  218,  218,    0,   69,
   69,  269,  269,  269,    0,  218,  218,  218,  218,  218,
  218,  218,  218,  218,   90,    0,    0,   90,  218,  218,
   90,    0,  218,  218,  218,  218,  218,    0,    0,    0,
    0,    0,    0,    0,    0,  142,   90,    0,  142,    0,
  269,    0,  241,  242,  243,  244,    0,    0,    0,    0,
    0,    0,  245,  246,    0,    0,    0,    0,  218,    0,
    0,    0,   36,    0,  193,  194,  195,  196,  197,  198,
  199,  200,    0,    0,    0,    0,  293,  294,    0,    0,
    0,  201,  202,    0,    0,    0,    0,    0,   69,    0,
  218,    0,  218,  218,  218,  218,  218,    0,    0,    0,
    0,    0,    0,    0,   36,   33,   34,    0,  218,  218,
  218,  218,    0,    0,  218,  218,  218,  218,  218,  218,
  218,  218,  218,  218,    0,    0,    0,    0,  218,  218,
   69,  219,  219,  219,  219,  219,  219,  219,  219,  219,
    0,    0,    0,    0,    0,    0,    0,    0,  219,  219,
    0,   70,   70,    0,    0,    0,    0,  219,  219,  219,
  219,  219,  219,  219,  219,  219,    0,    0,    0,    0,
  219,  219,    0,    0,  219,  219,  219,  219,  219,  167,
  168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
  178,  179,  180,  181,  182,  183,  184,  185,  186,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  219,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   70,    0,  219,    0,  219,  219,  219,  219,  219,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  219,  219,  219,  219,    0,    0,  219,  219,  219,  219,
  219,  219,  219,  219,  219,  219,    0,    0,    0,    0,
  219,  219,   70,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,   46,   47,   48,   49,   50,    0,
   51,   52,   53,   54,   55,   56,   57,   58,   59,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  162,    0,
    0,    0,    0,    0,    0,   61,  163,  164,   64,   65,
   66,   67,   68,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   71,    0,   72,    0,    0,    0,    0,    0,
   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
   85,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
   93,    0,    0,    0,    0,    0,   95,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  102,  103,
  104,  105,  165,    0,    0,    0,    0,   19,   19,   19,
   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
   19,   19,   19,  107,   19,   19,   19,   19,   19,   19,
   19,   19,   19,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   19,    0,    0,    0,    0,    0,    0,   19,
   19,   19,   19,   19,   19,   19,   19,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   19,    0,   19,    0,
    0,    0,    0,    0,   19,   19,   19,   19,   19,   19,
   19,   19,   19,   19,   19,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   19,   19,    0,    0,    0,    0,    0,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  193,  194,  195,  196,  197,  198,  199,  200,   19,    0,
    0,    0,   19,   19,   19,   19,   19,  201,  202,    0,
    0,    0,    0,    0,    0,    0,   24,   25,   26,  203,
  204,  205,  206,  207,  208,    0,    0,   19,    0,   31,
   32,    0,    0,  209,  210,  211,  212,  213,    0,    0,
    0,    0,    0,    0,  127,  128,  129,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  130,  131,    0,  132,
  133,  134,  135,  136,  137,    0,    0,  138,    0,  214,
    0,    0,    0,    0,    0,    0,    0,  139,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  215,    0,   73,   74,  216,  217,  218,    0,  140,
  141,  142,  143,  144,  145,  146,  147,  148,  149,   86,
   87,   88,   89,    0,    0,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,    0,    0,    0,    0,  229,
  230,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  150,  151,  152,
  153,
};
short milcheck[] = {                                       2,
  353,  351,   90,  272,  273,  274,  275,  353,  257,  284,
  285,  351,  343,  287,  345,  351,  356,  286,  288,  289,
  350,  290,  291,  292,  257,  312,  313,  314,  350,    0,
  299,  300,  301,  302,  303,  304,  305,  306,  351,   10,
  278,  279,  280,  262,  263,  283,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  257,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  422,  346,  346,  284,  285,  351,  346,  419,
  350,  350,  422,  419,  354,  355,  422,  287,  357,  358,
  359,  360,  361,  362,  363,  364,  345,  287,  373,  345,
  369,  370,  190,  191,  257,  374,  353,  376,  377,  378,
  343,  353,  345,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  258,  259,  260,  261,  372,  365,  366,  437,  371,  409,
  415,  351,  411,  412,  284,  285,  351,  346,  417,  418,
  345,  423,  424,  425,  426,  420,  421,  160,  427,  428,
  429,  430,  431,  432,  373,  435,  436,  438,  345,  257,
  258,  440,  441,  442,  443,  444,  371,  410,  416,  272,
  273,  274,  275,  350,  346,  439,  344,  257,  257,  346,
  343,  346,  345,  286,  346,  346,  465,  290,  291,  292,
  438,  257,  346,  346,  352,  366,  415,  300,  301,  302,
  303,  304,  305,  306,  347,  239,  346,  257,  371,  273,
  274,  275,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,  345,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  356,  347,
  253,  346,  257,  419,  346,  279,  280,  350,  422,  343,
  347,  284,  285,  346,  357,  358,  359,  360,  361,  362,
  363,  364,  257,  347,  257,  347,  369,  370,  257,  347,
  351,  374,  257,  376,  377,  378,  284,  285,  347,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  278,  279,  280,  344,
  351,  283,  284,  285,    0,  369,  370,  351,  411,  412,
  351,   10,  247,  319,  417,  418,  269,  126,  351,  352,
  284,  285,  258,  356,  427,  428,  429,  430,  431,  432,
  336,  337,  365,  366,  286,  369,  286,  440,  441,  442,
  443,  444,  376,  351,  352,  286,  380,  286,  356,  383,
  343,  325,  345,  359,  286,   27,  340,  109,  155,   -1,
   -1,   -1,  465,  427,  428,  429,  430,  431,  432,  351,
  352,   -1,   -1,   -1,  356,   -1,   -1,   -1,  371,   -1,
   -1,   -1,   -1,  365,  366,  346,  419,  351,   -1,  422,
  372,   -1,  356,  284,  285,   -1,  287,   -1,   -1,  264,
  265,  266,  267,  268,  269,  270,  271,  272,   -1,   -1,
   -1,  419,   -1,   -1,  422,   -1,  281,  282,   -1,  284,
  285,  312,  313,  314,   -1,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  416,   -1,   -1,  419,  303,  304,
  422,   -1,  307,  308,  309,  310,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  419,  438,   -1,  422,   -1,
  351,   -1,  423,  424,  425,  426,   -1,   -1,   -1,   -1,
   -1,   -1,  433,  434,   -1,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  373,   -1,  264,  265,  266,  267,  268,  269,
  270,  271,   -1,   -1,   -1,   -1,  276,  277,   -1,   -1,
   -1,  281,  282,   -1,   -1,   -1,   -1,   -1,  373,   -1,
  375,   -1,  377,  378,  379,  380,  381,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  415,  305,  306,   -1,  393,  394,
  395,  396,   -1,   -1,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,   -1,   -1,   -1,   -1,  413,  414,
  415,  264,  265,  266,  267,  268,  269,  270,  271,  272,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  281,  282,
   -1,  284,  285,   -1,   -1,   -1,   -1,  290,  291,  292,
  293,  294,  295,  296,  297,  298,   -1,   -1,   -1,   -1,
  303,  304,   -1,   -1,  307,  308,  309,  310,  311,  445,
  446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
  456,  457,  458,  459,  460,  461,  462,  463,  464,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  373,   -1,  375,   -1,  377,  378,  379,  380,  381,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  393,  394,  395,  396,   -1,   -1,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,   -1,   -1,   -1,   -1,
  413,  414,  415,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
  332,  333,  334,  335,  336,  337,  338,  339,  340,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,
   -1,   -1,   -1,   -1,   -1,  357,  358,  359,  360,  361,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  374,   -1,  376,   -1,   -1,   -1,   -1,   -1,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  411,
  412,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,  443,  444,   -1,   -1,   -1,   -1,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  465,  332,  333,  334,  335,  336,  337,
  338,  339,  340,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  350,   -1,   -1,   -1,   -1,   -1,   -1,  357,
  358,  359,  360,  361,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
   -1,   -1,   -1,   -1,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  411,  412,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  264,  265,  266,  267,  268,  269,  270,  271,  272,   -1,
   -1,   -1,  440,  441,  442,  443,  444,  281,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,  292,  293,
  294,  295,  296,  297,  298,   -1,   -1,  465,   -1,  303,
  304,   -1,   -1,  307,  308,  309,  310,  311,   -1,   -1,
   -1,   -1,   -1,   -1,  317,  318,  319,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  329,  330,   -1,  332,
  333,  334,  335,  336,  337,   -1,   -1,  340,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,  377,  378,  379,  380,  381,   -1,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  393,
  394,  395,  396,   -1,   -1,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,   -1,   -1,   -1,   -1,  413,
  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
  443,
};
#define YYFINAL 9
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 465
#if YYDEBUG
char *milname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"INTEGER","RELNOTA","RELPAUSA",
"RELSTAFF","RELNOTES","DEFAULTX","ALTERNATIVE","ONLEFT","ONRIGHT","BELOW",
"ABOVE","STEMUP","STEMDOWN","BEAM12","BEAM23","INMULTISTAFF","ONSTAFFNUMBER",
"STAFFNUMBER","STAFFLINES","SAMESTEMONLEFT","SAMESTEMONRIGHT","AVOIDINSTAFF",
"OUTSIDESTAFF","ANYWHERE","ONSPACE","ONLINE","ONSTAFF","DOWNWARDS","UPWARDS",
"PAUSA","THEN","immIF","posIF","INMULTIVOICEUPPER","INMULTIVOICELOWER",
"INENDBATTUTA","INBEAM","INTUPLET","INPUNTOVALORE","INCHORDSUSPENDED",
"INSTACCATO","INLEGVALORE","NOT","NOTE","NEARNOTA","NEARNOTES","INCHORD",
"INMULTIVOICE","OPPOSITETOSTEM","ONSTEM","SUSPENDED","UPPER","LOWER",
"INTERMEDIATE","CAMBIOCHIAVE","AND","OR","XOR","APP","ACC","GRUP","MORD",
"TRILLO","TREM","ARP","GLISS","DIESIS","BEMOL","DOPDIES","DOPBEMOL","MONES",
"TRIES","LEG","STAC","IDENTIFIER","SFOR","ACCE","MARTF","TEN","MART","PUNTOALL",
"LEGVAL","PUNTOVAL","CORONA","LEFTPAR","RIGHTPAR","LEFTPARQ","RIGHTPARQ","REAL",
"EQUAL","COMMA","MAGGIORE","MINORE","STRING","SEMICOLON","SCALE","RULE_NAME",
"RULEPOS","RULEIMM","ANGLE","STEM","PSEMIBREVE","PMINIMA","PSEMIMINIMA",
"PCROMA","PSEMICROMA","PBISCROMA","PSEMIBISCROMA","DELTAX","DELTAY","UPPERDIST",
"LOWERDIST","NUMDOWN","NUMUP","VAR","LENGHT","WITH","BEAM","INCHORDTRE",
"ALTERAZIONE","INCHORDSETTIMA","INCHORDminSETTIMA","INCHORDSUSPINTERM",
"INCHORDSUSPUPPER","INCHORDSUSPLOWER","ARCATA","PIZZICATO","CORDA","ARCATASU",
"ARCATAGIU","PUNTA","TALLONE","PONTICELLO","TASTIERA","ARCO","OTTAVA",
"INOTTAVASOPRA","INOTTAVASOTTO","INTWOSTAFF","INSINGLELAYER","NOTAWITH","NOTES",
"BISCROMA","SEMIBISCROMA","FUSA","CROMA","SEMICROMA","SEMIMINIMA","MINIMA",
"SEMIBREVE","BREVE","NOTINA","RULEPRI","STEMHEIGHT","MOBEMOL","TRIBEMOL",
"FIRSTUPPER","FIRSTLOWER","PRECEED","NBEAT","TIME","BATTUTA","COPPIE","OFF",
"ON","GTinBEAT","GREATER","LOWer","LOWERe","GREATERe","UPPERD","LOWERD","MEAN",
"DELTA","BEAMDIS","MHL","PLUS","MIN","DEFGROUP","DEFSYM","GROUP","CODE","DIM",
"CONSORD","VIASORD","ARM","DITEG","HEAD","CLASSIC","ALPHANUM","ALPHANUM_SQUARE",
"ALPHANUM_REVERSE","CIRCLEX","CLUSTER","X_HEAD","CROIX","DDIESIS","DIAMOND",
"TRIANG","TRIANG_UP","TRIANG_DOWN","TRIANG_LEFT","TRIANG_RIGHT","TRIANG_ROUND",
"MOON","PLUS_HEAD","RHYTHMIC","SQUARE","STEMSTART",
};
char *milrule[] = {
"$accept : MILLA",
"MILLA : IstMILLA",
"MILLA : IstMILLA MILLA",
"BodyIstMILLA : Situation",
"BodyIstMILLA : FixedRule",
"BodyIstMILLA : Assignment",
"BodyIstMILLA : Priority",
"BodyIstMILLA : DefNewSymbol",
"BodyIstMILLA : DefNewGroup",
"IstMILLA : BodyIstMILLA SEMICOLON",
"DefNewGroup : DEFGROUP STRING",
"$$1 :",
"DefNewSymbol : DEFSYM STRING $$1 Group Code Dim",
"Code : CODE EQUAL INTEGER",
"Group : GROUP EQUAL STRING",
"Dim :",
"Dim : DIM EQUAL INTEGER COMMA INTEGER COMMA INTEGER COMMA INTEGER COMMA INTEGER COMMA INTEGER",
"FixedRule : RULEIMM RULE_NAME Type Rule",
"FixedRule : RULEPOS RULE_NAME Type Rule",
"Type :",
"Type : DEFAULTX",
"Type : ALTERNATIVE",
"Rule : Symbol rel cat staff coord other",
"Symbol : STEM",
"Symbol : HEAD",
"Symbol : STEMSTART",
"Symbol : BEAM",
"Symbol : OTTAVA",
"Symbol : BATTUTA",
"Symbol : Abbellimenti",
"Symbol : Indicazioni",
"Symbol : Alterazioni",
"Symbol : Espressione",
"Symbol : VariazValore",
"Symbol : Pause",
"Symbol : Archi",
"Symbol : STRING",
"Abbellimenti : APP",
"Abbellimenti : ACC",
"Abbellimenti : GRUP",
"Abbellimenti : MORD",
"Abbellimenti : TRILLO",
"Abbellimenti : TREM",
"Abbellimenti : ARP",
"Abbellimenti : GLISS",
"Indicazioni : CONSORD",
"Indicazioni : VIASORD",
"Indicazioni : ARM",
"Indicazioni : DITEG",
"Alterazioni : DIESIS",
"Alterazioni : BEMOL",
"Alterazioni : DOPDIES",
"Alterazioni : DOPBEMOL",
"Alterazioni : MONES",
"Alterazioni : TRIES",
"Alterazioni : ALTERAZIONE",
"Alterazioni : MOBEMOL",
"Alterazioni : TRIBEMOL",
"Espressione : LEG",
"Espressione : STAC",
"Espressione : SFOR",
"Espressione : ACCE",
"Espressione : MARTF",
"Espressione : TEN",
"Espressione : MART",
"Espressione : PUNTOALL",
"VariazValore : LEGVAL",
"VariazValore : PUNTOVAL",
"VariazValore : CORONA",
"Pause : PSEMIBREVE",
"Pause : PMINIMA",
"Pause : PSEMIMINIMA",
"Pause : PCROMA",
"Pause : PSEMICROMA",
"Pause : PBISCROMA",
"Pause : PSEMIBISCROMA",
"Archi : ARCATA",
"Archi : PIZZICATO",
"Archi : CORDA",
"Archi : ARCATASU",
"Archi : ARCATAGIU",
"Archi : PUNTA",
"Archi : TALLONE",
"Archi : PONTICELLO",
"Archi : TASTIERA",
"Archi : ARCO",
"rel : RELNOTA",
"rel : RELPAUSA",
"rel : RELSTAFF",
"rel : RELNOTES",
"cat :",
"cat : wheresimbolo",
"cat : belwab",
"cat : stem",
"cat : spaceline",
"cat : rightleft",
"cat : SAMESTEMONLEFT",
"cat : SAMESTEMONRIGHT",
"rightleft : ONLEFT",
"rightleft : ONRIGHT",
"wheresimbolo : OPPOSITETOSTEM",
"wheresimbolo : ONSTEM",
"belwab : BELOW",
"belwab : ABOVE",
"stem : STEMUP",
"stem : STEMDOWN",
"stem : BEAM12",
"stem : BEAM23",
"staff :",
"staff : AVOIDINSTAFF",
"staff : OUTSIDESTAFF",
"staff : ANYWHERE",
"staff : ONSTAFF",
"staff : lenght",
"staff : code",
"staff : nbeat",
"spaceline : ONSPACE",
"spaceline : ONLINE",
"lenght : LENGHT EQUAL REAL",
"lenght : LENGHT EQUAL INTEGER",
"lenght : LENGHT EQUAL VAR",
"lenght : LENGHT EQUAL Range",
"lenght : LENGHT EQUAL STEMHEIGHT",
"code : CODE EQUAL INTEGER",
"nbeat : NBEAT EQUAL REAL",
"nbeat : NBEAT EQUAL INTEGER",
"Range : LEFTPARQ singlevalue SEMICOLON singlevalue RIGHTPARQ",
"coord :",
"coord : dx dy",
"coord : dy",
"dx : DELTAX EQUAL REAL",
"dx : DELTAX EQUAL INTEGER",
"dx : DELTAX EQUAL VAR",
"dx : DELTAX EQUAL Range",
"dy : DELTAY EQUAL REAL",
"dy : DELTAY EQUAL INTEGER",
"dy : DELTAY EQUAL VAR",
"dy : DELTAY EQUAL Range",
"singlevalue : REAL",
"singlevalue : INTEGER",
"singlevalue : VAR",
"other : scale shape angle coppie abilterzine",
"scale :",
"scale : SCALE EQUAL REAL",
"angle :",
"angle : ANGLE EQUAL REAL",
"angle : ANGLE EQUAL Range",
"shape :",
"shape : shapeis",
"shapeis : DOWNWARDS",
"shapeis : UPWARDS",
"coppie :",
"coppie : COPPIE EQUAL LEFTPARQ singlevalue COMMA singlevalue SEMICOLON singlevalue COMMA singlevalue RIGHTPARQ",
"abilterzine :",
"abilterzine : GTinBEAT EQUAL OFF",
"abilterzine : GTinBEAT EQUAL ON",
"Situation : immIF TypeCondition THEN RULE_NAME",
"Situation : posIF TypeCondition THEN RULE_NAME",
"TypeCondition : condition",
"TypeCondition : condition OpBool TypeCondition",
"TypeCondition : NOT condition",
"condition : notapausa wherenotapausa",
"condition : Symbol shapeis",
"condition : Symbol WITH Symbol",
"condition : NOTAWITH Symbol",
"condition : notapausa Range",
"condition : namecondition",
"condition : where",
"condition : wheresimbolo",
"condition : notapausa kind",
"condition : Symbol PRECEED Symbol",
"condition : time EQUAL singlevalue SEMICOLON singlevalue",
"condition : factor operation factor result REAL",
"condition : factor result REAL",
"condition : HEAD HeadType",
"HeadType : CLASSIC",
"HeadType : ALPHANUM",
"HeadType : ALPHANUM_SQUARE",
"HeadType : ALPHANUM_REVERSE",
"HeadType : CIRCLEX",
"HeadType : CLUSTER",
"HeadType : X_HEAD",
"HeadType : CROIX",
"HeadType : DDIESIS",
"HeadType : DIAMOND",
"HeadType : TRIANG",
"HeadType : TRIANG_UP",
"HeadType : TRIANG_DOWN",
"HeadType : TRIANG_LEFT",
"HeadType : TRIANG_RIGHT",
"HeadType : TRIANG_ROUND",
"HeadType : MOON",
"HeadType : PLUS_HEAD",
"HeadType : RHYTHMIC",
"HeadType : SQUARE",
"factor : UPPERD",
"factor : LOWERD",
"factor : NUMUP",
"factor : NUMDOWN",
"factor : MEAN",
"factor : DELTA",
"factor : BEAMDIS",
"factor : MHL",
"factor : STAFFNUMBER",
"factor : ONSTAFFNUMBER",
"factor : STAFFLINES",
"operation : PLUS",
"operation : MIN",
"result : GREATER",
"result : LOWer",
"result : GREATERe",
"result : LOWERe",
"result : EQUAL",
"time : TIME",
"notapausa : NOTE",
"notapausa : NOTES",
"notapausa : PAUSA",
"notapausa : NEARNOTA",
"notapausa : PSEMIBREVE",
"notapausa : PMINIMA",
"notapausa : NEARNOTES",
"wherenotapausa : where",
"wherenotapausa : spaceline",
"wherenotapausa : rightleft",
"wherenotapausa : INBEAM",
"wherenotapausa : INTUPLET",
"wherenotapausa : INPUNTOVALORE",
"wherenotapausa : INCHORDSUSPENDED",
"wherenotapausa : INCHORDTRE",
"wherenotapausa : INCHORDSUSPINTERM",
"wherenotapausa : INCHORDSUSPUPPER",
"wherenotapausa : INCHORDSUSPLOWER",
"wherenotapausa : INSTACCATO",
"wherenotapausa : INLEGVALORE",
"where : INCHORD",
"where : INMULTIVOICE",
"where : INMULTIVOICEUPPER",
"where : INMULTIVOICELOWER",
"where : INENDBATTUTA",
"where : INSINGLELAYER",
"where : INCHORDSETTIMA",
"where : INCHORDminSETTIMA",
"where : INOTTAVASOPRA",
"where : INOTTAVASOTTO",
"where : INTWOSTAFF",
"where : INMULTISTAFF",
"kind : stem",
"kind : belwab",
"kind : SUSPENDED",
"kind : UPPER",
"kind : LOWER",
"kind : INTERMEDIATE",
"kind : CAMBIOCHIAVE",
"kind : BISCROMA",
"kind : SEMIBISCROMA",
"kind : FUSA",
"kind : CROMA",
"kind : SEMICROMA",
"kind : FIRSTUPPER",
"kind : FIRSTLOWER",
"kind : SEMIMINIMA",
"kind : MINIMA",
"kind : SEMIBREVE",
"kind : BREVE",
"kind : NOTINA",
"OpBool : AND",
"OpBool : OR",
"OpBool : XOR",
"Assignment : namecondition EQUAL TypeCondition",
"namecondition : STRING",
"Priority : RULEPRI listsymbolpri",
"listsymbolpri :",
"listsymbolpri : symbolpri listsymbolpri",
"symbolpri : STAC",
"symbolpri : TEN",
"symbolpri : LEG",
"symbolpri : SFOR",
"symbolpri : ACCE",
"symbolpri : MARTF",
"symbolpri : MART",
"symbolpri : PUNTOALL",
"symbolpri : GRUP",
"symbolpri : MORD",
"symbolpri : TRILLO",
"symbolpri : ARCATA",
"symbolpri : ARCO",
"symbolpri : PIZZICATO",
"symbolpri : CORDA",
"symbolpri : ARCATASU",
"symbolpri : ARCATAGIU",
"symbolpri : PUNTA",
"symbolpri : TALLONE",
"symbolpri : PONTICELLO",
"symbolpri : TASTIERA",
"symbolpri : CORONA",
"symbolpri : DITEG",
"symbolpri : ARM",
"symbolpri : CONSORD",
"symbolpri : VIASORD",
"symbolpri : STRING",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1268 "./mil/lgiust.y"

/* ------ Program section ------ */

void milerror(char *msg)  
{
  printf("Milla: %s line %d %s",msg,millineno,miltext);
  milloadError=1;
  fclose(milin);
  return;
}

void InitLoad(Immissione* pruleimm, Posiz* prulepos,
Priorita* prulepri, Simboli* psymbol)
{
  pimm = pruleimm;
  ppos = prulepos;
  ppri = prulepri;
  psym = psymbol;  
  
  
  // Fa il sort delle keywords per load
  qsort(MilKeywords, MilKeywordNumber, sizeof(KEYWORDMIL), MilCompareId);
  millineno = 1;
  milloadError = 0;
  
  CurrentColImm=0;
  CurrentColPos=0;
  pimm->Reset();
  ppos->Reset();
  ppri->Reset();
  psym->Reset();
}

void SetType()
{
   if (CurrentRuleImm!=NULL) 
   
   /*il puntatore CurrentRuleImm e' diverso da zero solo se sto 
     definendo una nuova regola. In questo caso allora non occorre
     piu' inrule=2*/
     
   {
     CurrentRuleImm->Type=lasttoken;
  
   /*questa operazione associa al campo Type della struttura ITEMIMM
     il numero associato al token che ha riconosciuto, in questo caso
     DEFAULT o ALTERNATIVE*/
     
   }
   
/*  if (CurrentRulePos!=NULL) 
   
   /*il puntatore CurrentRulePos e' diverso da zero solo se sto 
     definendo una nuova regola. In questo caso allora non occorre
     piu' inrule=2*/
     
  /* {
     CurrentRulePos->Type=lasttoken;
  
   /*questa operazione associa al campo Type della struttura ITEMPOS
     il numero associato al token che ha riconosciuto, in questo caso
     DEFAULT o ALTERNATIVE*/
     
  /* } */
}

void SetSymbol()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->Symbol=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->Symbol=lasttoken;
   }
 
} 

void Setrel()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->rel=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->rel=lasttoken;
   }
   
 
}

void Setcat()
{
   if (CurrentRuleImm!=NULL) 
   {
     CurrentRuleImm->cat=lasttoken;
   }
   
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->cat=lasttoken;
   }
}

void Setstaff()
{
   if (CurrentRulePos!=NULL) 
   {
     CurrentRulePos->staff=lasttoken;
   }
 
} 

void SetCol()
{ 
  if (CurrentColImm<20)
   {
     if (CurrentCondImm!=NULL)
      {
       CurrentCondImm->condizioni[CurrentColImm++].cond=lasttoken;
       CurrentCondImm->numCond++;
      }
   }
  if (CurrentColPos<20)
   {
     if (CurrentCondPos!=NULL)
      {
       CurrentCondPos->condizioni[CurrentColPos++].cond=lasttoken;
       CurrentCondPos->numCond++;
      }
   } 
}

void SetCondizione()
{
 if (CurrentColImm<20)
 {
   if (CurrentCondImm!=NULL)
    {
     CurrentCondImm->condizioni[CurrentColImm++].cond=1000*token+lasttoken;
     CurrentCondImm->numCond++;
    }
  }
 if (CurrentColPos<20)
 {
   if (CurrentCondPos!=NULL)
    {
     CurrentCondPos->condizioni[CurrentColPos++].cond=1000*token+lasttoken;
     CurrentCondPos->numCond++;
    }
  } 
}  
    



/*main()
{ 
    //Legge da un file 
  milin = fopen( "Milla", "r" );

  if(milin == NULL)
  {
    printf("File non trovato");
    exit(1);
  } 

  InitLoad();

  yyparse();

/*Eseguo l'ordinamento per simboli come ultima operazione in modo
da mantenere quella precedente in fase di elaborazione*/

/*  ruleManager.sortSymbol();
  ruleManager.sortCondition();
  ruleManager.seeItemListImm();
  ruleManager.seeItemListPos();
  ruleManager.seeConditionList();
  
  
  printf("Digitare il token relativo al simbolo da cercare:\n");
  scanf("%d",&CurrentItemImm.Symbol);
  pimm.searchSymbolImm(CurrentItemImm.Symbol);
  CurrentItemPos.Symbol=CurrentItemImm.Symbol;
  ppos.searchSymbolPos(CurrentItemPos.Symbol);

  fclose(milin);

  if(milloadError==1)
  {
    printf("Error in line %d",millineno);
    exit(1);
  } else 
  {
    printf("No error");
  }
   
 
  
  
}*/



#line 1339 "./mil/m.tab.cpp"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 10:
#line 354 "./mil/lgiust.y"
{ 
			   psym->AddGroup(yyvsp[0].string);
			 }
break;
case 11:
#line 358 "./mil/lgiust.y"
{ psym->AddSymbolName(yyvsp[0].string);}
break;
case 12:
#line 359 "./mil/lgiust.y"
{ psym->Incrementa();}
break;
case 13:
#line 363 "./mil/lgiust.y"
{
	    psym->AddCode(yyvsp[0].integer);
	  }
break;
case 14:
#line 368 "./mil/lgiust.y"
{
	     psym->AddGroupName(yyvsp[0].string);
	   }
break;
case 16:
#line 374 "./mil/lgiust.y"
{
	     psym->AddDim(yyvsp[-10].integer,yyvsp[-8].integer,yyvsp[-6].integer,yyvsp[-4].integer,yyvsp[-2].integer,yyvsp[0].integer);
	   }
break;
case 17:
#line 378 "./mil/lgiust.y"
{ CurrentRuleImm = NULL; }
break;
case 18:
#line 379 "./mil/lgiust.y"
{ CurrentRulePos = NULL; }
break;
case 20:
#line 382 "./mil/lgiust.y"
{ SetType(); }
break;
case 21:
#line 384 "./mil/lgiust.y"
{ SetType(); }
break;
case 23:
#line 389 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 24:
#line 394 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 25:
#line 399 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 26:
#line 405 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 27:
#line 410 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 28:
#line 415 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 29:
#line 420 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 30:
#line 425 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 31:
#line 430 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 32:
#line 435 "./mil/lgiust.y"
{ 
	    yyval.integer = lasttoken;
	    SetSymbol();
	 }
break;
case 33:
#line 440 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 34:
#line 445 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 35:
#line 450 "./mil/lgiust.y"
{
	    yyval.integer = lasttoken;
	    SetSymbol(); 
	 }
break;
case 36:
#line 455 "./mil/lgiust.y"
{
	 /* ricavo la posizione della stringa corrispondente al nome del
*/
	 /* gruppo dall'array in cui l'ho definito....
*/
	 
	    
	    token=psym->GetGroupPos(yyvsp[0].string);
		/*printf("token=%d\n",token);
*/
	 
	    if(token!=-1)
		{
	     
	 	 /* adesso assegno un numero alla stringa dipendente proprio dal numero
*/
	     /* ricavato..
*/
	 
	      lasttoken=1000+token;		
		  SetSymbol();	
		}
		else 
		  printf("Line:%d Hai utilizzato nella regola un gruppo non definito\n", millineno);	 	    
	 }
break;
case 86:
#line 535 "./mil/lgiust.y"
{ Setrel(); }
break;
case 87:
#line 537 "./mil/lgiust.y"
{ Setrel(); }
break;
case 88:
#line 539 "./mil/lgiust.y"
{ Setrel(); }
break;
case 89:
#line 541 "./mil/lgiust.y"
{ Setrel(); }
break;
case 91:
#line 544 "./mil/lgiust.y"
{ Setcat(); }
break;
case 92:
#line 546 "./mil/lgiust.y"
{ Setcat(); }
break;
case 93:
#line 548 "./mil/lgiust.y"
{ Setcat(); }
break;
case 94:
#line 550 "./mil/lgiust.y"
{ Setcat(); }
break;
case 95:
#line 552 "./mil/lgiust.y"
{ Setcat(); }
break;
case 96:
#line 554 "./mil/lgiust.y"
{ Setcat(); }
break;
case 97:
#line 556 "./mil/lgiust.y"
{ Setcat(); }
break;
case 109:
#line 578 "./mil/lgiust.y"
{ Setstaff(); }
break;
case 110:
#line 580 "./mil/lgiust.y"
{ Setstaff(); }
break;
case 111:
#line 582 "./mil/lgiust.y"
{ Setstaff(); }
break;
case 112:
#line 584 "./mil/lgiust.y"
{ Setstaff(); }
break;
case 118:
#line 597 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=yyvsp[0].real;
		 }
	      }
break;
case 119:
#line 603 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=yyvsp[0].integer;
		 }
	      }
break;
case 120:
#line 610 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=lasttoken;
		 }
	      }
break;
case 121:
#line 616 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	     {	
               CurrentRulePos->rangelenght.min=CurrentRange.min;
               CurrentRulePos->rangelenght.max=CurrentRange.max;	
	     }  
           }
break;
case 122:
#line 623 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	     {	
               CurrentRulePos->lenght=lasttoken;	
	     }
           }
break;
case 123:
#line 630 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->code=yyvsp[0].integer;
		 }
	      }
break;
case 124:
#line 637 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=yyvsp[0].real;
		 }
	      }
break;
case 125:
#line 643 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	         {
		   CurrentRulePos->lenght=yyvsp[0].integer;
		 }
	      }
break;
case 126:
#line 652 "./mil/lgiust.y"
{
	   CurrentRange.min=yyvsp[-3].real;
	   CurrentRange.max=yyvsp[-1].real;
         }
break;
case 130:
#line 660 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dx=yyvsp[0].real;
          }
       }
break;
case 131:
#line 666 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
           CurrentRulePos->dx=yyvsp[0].integer;
          }
       }
break;
case 132:
#line 672 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dx=lasttoken;
          }
       }
break;
case 133:
#line 678 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangedx.min=CurrentRange.min;
            CurrentRulePos->rangedx.max=CurrentRange.max;	
	  }  
        }
break;
case 134:
#line 686 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dy=yyvsp[0].real;
          }
       }
break;
case 135:
#line 692 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
           CurrentRulePos->dy=yyvsp[0].integer;
          }
       }
break;
case 136:
#line 698 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {
            CurrentRulePos->dy=lasttoken;
          }
       }
break;
case 137:
#line 704 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangedy.min=CurrentRange.min;
            CurrentRulePos->rangedy.max=CurrentRange.max;	
	  }  
        }
break;
case 138:
#line 712 "./mil/lgiust.y"
{ yyval.real=yyvsp[0].real; }
break;
case 139:
#line 714 "./mil/lgiust.y"
{ yyval.real=yyvsp[0].integer; }
break;
case 140:
#line 716 "./mil/lgiust.y"
{ yyval.real=lasttoken; }
break;
case 143:
#line 721 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	    {
              CurrentRulePos->scale=yyvsp[0].real;
            }
          }
break;
case 145:
#line 728 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	    {
              CurrentRulePos->angle=yyvsp[0].real;
            }
          }
break;
case 146:
#line 740 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
	  {	
            CurrentRulePos->rangeangle.min=CurrentRange.min;
            CurrentRulePos->rangeangle.max=CurrentRange.max;	
	    CurrentRulePos->angle=BSLOPE;
	  }  
        }
break;
case 149:
#line 751 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
             {
               CurrentRulePos->shape=lasttoken;
             }
           }
break;
case 150:
#line 757 "./mil/lgiust.y"
{ if (CurrentRulePos!=NULL)
             {
               CurrentRulePos->shape=lasttoken;
             }
           }
break;
case 152:
#line 766 "./mil/lgiust.y"
{
	    CurrentRulePos->coppie[1].min=yyvsp[-7].real;
	    CurrentRulePos->coppie[1].max=yyvsp[-5].real;
	    CurrentRulePos->coppie[2].min=yyvsp[-3].real;
	    CurrentRulePos->coppie[2].max=yyvsp[-1].real;
           
	  }
break;
case 154:
#line 775 "./mil/lgiust.y"
{
	         CurrentRulePos->abilterzine=OFF;
	       }
break;
case 155:
#line 779 "./mil/lgiust.y"
{
	         CurrentRulePos->abilterzine=ON;
	       }
break;
case 156:
#line 784 "./mil/lgiust.y"
{ 
              /* printf("Rule name %s\n",$4);
*/
               
			   
	         CurrentCondImm->RuleName = (char *)malloc(strlen(yyvsp[0].string) + 1);
               if (CurrentCondImm->RuleName==NULL)
                 Errore("allocation","RuleName",0);
               strcpy(CurrentCondImm->RuleName, yyvsp[0].string);
               CurrentColImm=0; 
	       CurrentCondImm = NULL;
             }
break;
case 157:
#line 796 "./mil/lgiust.y"
{ 
             /*  printf("Rule name %s\n",$4);
*/
               CurrentCondPos->RuleName = (char *)malloc(strlen(yyvsp[0].string) + 1);
               if (CurrentCondPos->RuleName==NULL)
                 Errore("allocation","RuleName",0);
               strcpy(CurrentCondPos->RuleName, yyvsp[0].string);
               CurrentColPos=0; 
	       CurrentCondPos = NULL;
               }
break;
case 161:
#line 811 "./mil/lgiust.y"
{ 
	      token = yyvsp[-1].integer;
	      SetCondizione(); 
	    }
break;
case 162:
#line 816 "./mil/lgiust.y"
{ 
	      token = yyvsp[-1].integer;
	      SetCondizione(); 
	    }
break;
case 163:
#line 821 "./mil/lgiust.y"
{
	      token = yyvsp[-2].integer;
	      SetCondizione();
	    }
break;
case 164:
#line 826 "./mil/lgiust.y"
{
	      token = NOTAWITH;
	      SetCondizione();
	    }
break;
case 165:
#line 831 "./mil/lgiust.y"
{
	      if (CurrentColImm<20)
	      { if (CurrentCondImm!=NULL)
	       {
	        token = yyvsp[-1].integer;
                CurrentCondImm->condizioni[CurrentColImm].cond=token;
	        CurrentCondImm->condizioni[CurrentColImm].range.min=CurrentRange.min;
                CurrentCondImm->condizioni[CurrentColImm++].range.max=CurrentRange.max;
	        CurrentCondImm->numCond++;	
	       } 
	      }
	      if (CurrentColPos<20)
	      { if (CurrentCondPos!=NULL)
	       {
	        token = yyvsp[-1].integer;
                CurrentCondPos->condizioni[CurrentColPos].cond=token;
	        CurrentCondPos->condizioni[CurrentColPos].range.min=CurrentRange.min;
                CurrentCondPos->condizioni[CurrentColPos++].range.max=CurrentRange.max;
	        CurrentCondPos->numCond++;	
	       } 
	      }  
            }
break;
case 167:
#line 855 "./mil/lgiust.y"
{ 
	      SetCol();
	    }
break;
case 168:
#line 859 "./mil/lgiust.y"
{ 
	      SetCol();
	     }
break;
case 169:
#line 863 "./mil/lgiust.y"
{ 
	      token = yyvsp[-1].integer;
	      SetCondizione();
	    }
break;
case 170:
#line 868 "./mil/lgiust.y"
{
	      token = yyvsp[-2].integer;
	      SetCondizione();
	    }
break;
case 171:
#line 943 "./mil/lgiust.y"
{
	      if (CurrentColImm<20)
	      { 
	      if (CurrentCondImm!=NULL)
	       {
		 token = yyvsp[-4].integer;
        	 CurrentCondImm->condizioni[CurrentColImm].cond=token;
		 CurrentCondImm->condizioni[CurrentColImm].range.min=yyvsp[-2].real;
        	 CurrentCondImm->condizioni[CurrentColImm++].range.max=yyvsp[0].real;
		 CurrentCondImm->numCond++;	
		} 
	      }
	      if (CurrentColPos<20)
	      { 
	      if (CurrentCondPos!=NULL)
	       {
		 token = yyvsp[-4].integer;
        	 CurrentCondPos->condizioni[CurrentColPos].cond=token;
		 CurrentCondPos->condizioni[CurrentColPos].range.min=yyvsp[-2].real;
        	 CurrentCondPos->condizioni[CurrentColPos++].range.max=yyvsp[0].real;
		 CurrentCondPos->numCond++;	
		} 
	       }  
             }
break;
case 172:
#line 968 "./mil/lgiust.y"
{
	       if (CurrentColImm<20)
	       {
	        if (CurrentCondImm!=NULL)
	        {
		  token = yyvsp[-4].integer;
	          CurrentCondImm->condizioni[CurrentColImm].cond=RELATION;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f1=token;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.Op=yyvsp[-3].integer;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f2=yyvsp[-2].integer;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.res=yyvsp[-1].integer;
		  CurrentCondImm->condizioni[CurrentColImm++].conditionrel.num=yyvsp[0].real;
		  CurrentCondImm->numCond++;
		 }
	       } 
	       if (CurrentColPos<20)
	       {
	        if (CurrentCondPos!=NULL)
	        {
		  token = yyvsp[-4].integer;
	          CurrentCondPos->condizioni[CurrentColPos].cond=RELATION;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f1=token;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.Op=yyvsp[-3].integer;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f2=yyvsp[-2].integer;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.res=yyvsp[-1].integer;
		  CurrentCondPos->condizioni[CurrentColPos++].conditionrel.num=yyvsp[0].real;
		  CurrentCondPos->numCond++;
		 }
	       }
	     }
break;
case 173:
#line 999 "./mil/lgiust.y"
{
	       if (CurrentColImm<20)
	       {
	        if (CurrentCondImm!=NULL)
	        {
		  token = yyvsp[-2].integer;
	          CurrentCondImm->condizioni[CurrentColImm].cond=RELATION;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f1=token;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.Op=99;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.f2=99;
		  CurrentCondImm->condizioni[CurrentColImm].conditionrel.res=yyvsp[-1].integer;
		  CurrentCondImm->condizioni[CurrentColImm++].conditionrel.num=yyvsp[0].real;
		  CurrentCondImm->numCond++;
		 }
	       } 
	       if (CurrentColPos<20)
	       {
	        if (CurrentCondPos!=NULL)
	        {
		  token = yyvsp[-2].integer;
	          CurrentCondPos->condizioni[CurrentColPos].cond=RELATION;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f1=token;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.Op=99;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.f2=99;
		  CurrentCondPos->condizioni[CurrentColPos].conditionrel.res=yyvsp[-1].integer;
		  CurrentCondPos->condizioni[CurrentColPos++].conditionrel.num=yyvsp[0].real;
		  CurrentCondPos->numCond++;
		 }
	       }
	     }
break;
case 174:
#line 1030 "./mil/lgiust.y"
{
	     	token=HEAD;
	     	SetCondizione();
	     }
break;
case 175:
#line 1036 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 176:
#line 1038 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 177:
#line 1040 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 178:
#line 1042 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 179:
#line 1044 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 180:
#line 1046 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 181:
#line 1048 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 182:
#line 1050 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 183:
#line 1052 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 184:
#line 1054 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 185:
#line 1056 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 186:
#line 1058 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 187:
#line 1060 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 188:
#line 1062 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 189:
#line 1064 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 190:
#line 1066 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 191:
#line 1068 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 192:
#line 1070 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 193:
#line 1072 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 194:
#line 1074 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 195:
#line 1077 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 196:
#line 1079 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 197:
#line 1081 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 198:
#line 1083 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 199:
#line 1085 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 200:
#line 1087 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 201:
#line 1089 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 202:
#line 1091 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 203:
#line 1093 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 204:
#line 1095 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 205:
#line 1097 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 206:
#line 1101 "./mil/lgiust.y"
{ yyval.integer = PLUS; }
break;
case 207:
#line 1103 "./mil/lgiust.y"
{ yyval.integer = MIN; }
break;
case 208:
#line 1106 "./mil/lgiust.y"
{ yyval.integer = GREATER; }
break;
case 209:
#line 1108 "./mil/lgiust.y"
{ yyval.integer = LOWer; }
break;
case 210:
#line 1110 "./mil/lgiust.y"
{ yyval.integer = GREATERe; }
break;
case 211:
#line 1112 "./mil/lgiust.y"
{ yyval.integer = LOWERe; }
break;
case 212:
#line 1114 "./mil/lgiust.y"
{ yyval.integer = EQUAL; }
break;
case 213:
#line 1118 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 214:
#line 1121 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 215:
#line 1123 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 216:
#line 1125 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 217:
#line 1127 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 218:
#line 1129 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 219:
#line 1131 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 220:
#line 1133 "./mil/lgiust.y"
{ yyval.integer = lasttoken; }
break;
case 273:
#line 1199 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 274:
#line 1201 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 275:
#line 1203 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 276:
#line 1205 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 277:
#line 1207 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 278:
#line 1209 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 279:
#line 1211 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 280:
#line 1213 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 281:
#line 1215 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 282:
#line 1217 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 283:
#line 1219 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 284:
#line 1221 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 285:
#line 1223 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 286:
#line 1225 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 287:
#line 1227 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 288:
#line 1229 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 289:
#line 1231 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 290:
#line 1233 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 291:
#line 1235 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 292:
#line 1237 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 293:
#line 1239 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 294:
#line 1241 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 295:
#line 1243 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 296:
#line 1245 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 297:
#line 1247 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 298:
#line 1249 "./mil/lgiust.y"
{ ppri->AddPriority(lasttoken);}
break;
case 299:
#line 1251 "./mil/lgiust.y"
{ 	 
			  /* ricavo la posizione della stringa corrispondente al nome del
*/
	          /* simbolo dall'array ....
*/
	 	     
		      token=psym->GetSymbolPos(yyvsp[0].string);
	          if(token!=-1)
		      {

	          /* adesso assegno un numero alla stringa dipendente proprio 
*/
			  /*dal numero ricavato..	         
*/
		        
				ppri->AddPriorityGen(2000+token);
			  }
			  else 
			   printf("Linea:%d Hai inserito nella lista delle priorita' un simbolo non definito\n",millineno);
			}
break;
#line 2428 "./mil/m.tab.cpp"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
