/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

#define INTEGER 257
#define RELNOTA 258
#define RELPAUSA 259
#define RELSTAFF 260
#define RELNOTES 261
#define DEFAULTX 262
#define ALTERNATIVE 263
#define ONLEFT 264
#define ONRIGHT 265
#define BELOW 266
#define ABOVE 267
#define STEMUP 268
#define STEMDOWN 269
#define BEAM12 270
#define BEAM23 271
#define INMULTISTAFF 272
#define ONSTAFFNUMBER 273
#define STAFFNUMBER 274
#define STAFFLINES 275
#define SAMESTEMONLEFT 276
#define SAMESTEMONRIGHT 277
#define AVOIDINSTAFF 278
#define OUTSIDESTAFF 279
#define ANYWHERE 280
#define ONSPACE 281
#define ONLINE 282
#define ONSTAFF 283
#define DOWNWARDS 284
#define UPWARDS 285
#define PAUSA 286
#define THEN 287
#define immIF 288
#define posIF 289
#define INMULTIVOICEUPPER 290
#define INMULTIVOICELOWER 291
#define INENDBATTUTA 292
#define INBEAM 293
#define INTUPLET 294
#define INPUNTOVALORE 295
#define INCHORDSUSPENDED 296
#define INSTACCATO 297
#define INLEGVALORE 298
#define NOT 299
#define NOTE 300
#define NEARNOTA 301
#define NEARNOTES 302
#define INCHORD 303
#define INMULTIVOICE 304
#define OPPOSITETOSTEM 305
#define ONSTEM 306
#define SUSPENDED 307
#define UPPER 308
#define LOWER 309
#define INTERMEDIATE 310
#define CAMBIOCHIAVE 311
#define AND 312
#define OR 313
#define XOR 314
#define APP 315
#define ACC 316
#define GRUP 317
#define MORD 318
#define TRILLO 319
#define TREM 320
#define ARP 321
#define GLISS 322
#define DIESIS 323
#define BEMOL 324
#define DOPDIES 325
#define DOPBEMOL 326
#define MONES 327
#define TRIES 328
#define LEG 329
#define STAC 330
#define IDENTIFIER 331
#define SFOR 332
#define ACCE 333
#define MARTF 334
#define TEN 335
#define MART 336
#define PUNTOALL 337
#define LEGVAL 338
#define PUNTOVAL 339
#define CORONA 340
#define LEFTPAR 341
#define RIGHTPAR 342
#define LEFTPARQ 343
#define RIGHTPARQ 344
#define REAL 345
#define EQUAL 346
#define COMMA 347
#define MAGGIORE 348
#define MINORE 349
#define STRING 350
#define SEMICOLON 351
#define SCALE 352
#define RULE_NAME 353
#define RULEPOS 354
#define RULEIMM 355
#define ANGLE 356
#define STEM 357
#define PSEMIBREVE 358
#define PMINIMA 359
#define PSEMIMINIMA 360
#define PCROMA 361
#define PSEMICROMA 362
#define PBISCROMA 363
#define PSEMIBISCROMA 364
#define DELTAX 365
#define DELTAY 366
#define UPPERDIST 367
#define LOWERDIST 368
#define NUMDOWN 369
#define NUMUP 370
#define VAR 371
#define LENGHT 372
#define WITH 373
#define BEAM 374
#define INCHORDTRE 375
#define ALTERAZIONE 376
#define INCHORDSETTIMA 377
#define INCHORDminSETTIMA 378
#define INCHORDSUSPINTERM 379
#define INCHORDSUSPUPPER 380
#define INCHORDSUSPLOWER 381
#define ARCATA 382
#define PIZZICATO 383
#define CORDA 384
#define ARCATASU 385
#define ARCATAGIU 386
#define PUNTA 387
#define TALLONE 388
#define PONTICELLO 389
#define TASTIERA 390
#define ARCO 391
#define OTTAVA 392
#define INOTTAVASOPRA 393
#define INOTTAVASOTTO 394
#define INTWOSTAFF 395
#define INSINGLELAYER 396
#define NOTAWITH 397
#define NOTES 398
#define BISCROMA 399
#define SEMIBISCROMA 400
#define FUSA 401
#define CROMA 402
#define SEMICROMA 403
#define SEMIMINIMA 404
#define MINIMA 405
#define SEMIBREVE 406
#define BREVE 407
#define NOTINA 408
#define RULEPRI 409
#define STEMHEIGHT 410
#define MOBEMOL 411
#define TRIBEMOL 412
#define FIRSTUPPER 413
#define FIRSTLOWER 414
#define PRECEED 415
#define NBEAT 416
#define TIME 417
#define BATTUTA 418
#define COPPIE 419
#define OFF 420
#define ON 421
#define GTinBEAT 422
#define GREATER 423
#define LOWer 424
#define LOWERe 425
#define GREATERe 426
#define UPPERD 427
#define LOWERD 428
#define MEAN 429
#define DELTA 430
#define BEAMDIS 431
#define MHL 432
#define PLUS 433
#define MIN 434
#define DEFGROUP 435
#define DEFSYM 436
#define GROUP 437
#define CODE 438
#define DIM 439
#define CONSORD 440
#define VIASORD 441
#define ARM 442
#define DITEG 443
#define HEAD 444
#define CLASSIC 445
#define ALPHANUM 446
#define ALPHANUM_SQUARE 447
#define ALPHANUM_REVERSE 448
#define CIRCLEX 449
#define CLUSTER 450
#define X_HEAD 451
#define CROIX 452
#define DDIESIS 453
#define DIAMOND 454
#define TRIANG 455
#define TRIANG_UP 456
#define TRIANG_DOWN 457
#define TRIANG_LEFT 458
#define TRIANG_RIGHT 459
#define TRIANG_ROUND 460
#define MOON 461
#define PLUS_HEAD 462
#define RHYTHMIC 463
#define SQUARE 464
#define STEMSTART 465
#define KORN	466

typedef union {
     double real;
     int integer;
     char *string;
} YYSTYPE;
extern YYSTYPE millval;

