/* ISO_HEADER_START */

/*********************************************************************

This software module was originally developed by

  Pierfrancesco Bellini (DISIT-DSI, University of Florence)
  Paolo Nesi (DISIT-DSI, University of Florence)
  Maurizio Campanai (EXITECH)

in the course of development of the MPEG-4 standard.
This software module is an implementation of a part of one or more
MPEG-4 tools as specified by the MPEG-4 standard. ISO/IEC gives users
of the MPEG-4 standard free license to this software module or
modifications thereof for use in hardware or software products
claiming conformance to MPEG-4. Those intending to use this software
module in hardware or software products are advised that its use may
infringe existing patents.  The original developer of this software
module and his/her company, the subsequent editors and their
companies, and ISO/IEC have no liability for use of this software
module or modifications thereof in an implementation.  Copyright is
not released for non MPEG-4 conforming products. The DISIT-DSI and 
EXITECH retains full right to use the code for its own purpose,
assign or donate the code to a third party and to inhibit third
parties from using the code for non MPEG-4 conforming products.  This
copyright notice must be included in all copies or derivative
works. Copyright (c) 2005.

***********************************************************************/

/* ISO_HEADER_END */

/* $Id: parentesi.cpp,v 1.1 2005/07/25 16:31:42 bellinpo Exp $ */


short int num_par,fineparentesi,inizioparentesi,tipoparentesi,numcodepar;
num_par=listaPar.GetNumObj();
infoCode = CodeCommand((short int)num_par,Codice);
strcat(Array,Codice); 

pPar = listaPar.GetFirstPar();   
while (pPar!=NULL)
{
	tipoparentesi = pPar->GetID();
	inizioparentesi = pPar->GetPSpaStart()->GetNumericCode();
	fineparentesi = pPar->GetPSpaEnd()->GetNumericCode();
	numcodepar = pPar->GetNumericCode();
	
	infoCode = CodeCommand((short int)tipoparentesi,Codice);
	strcat(Array,Codice); 
	
	infoCode = CodeCommand((short int)inizioparentesi,Codice);
	strcat(Array,Codice); 
	
	infoCode = CodeCommand((short int)fineparentesi,Codice);
	strcat(Array,Codice);   
	
	infoCode = CodeCommand((short int)numcodepar,Codice);
	strcat(Array,Codice);   
	
	pPar = listaPar.GetNextPar(pPar);
}


//trattamento lista delle parentesi  
// 1) prendo il numero delle parentesi	
strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
CommandStringa[DIM_COMMAND_STRING] = '\0';
CommandCode = DecodeCommand(CommandStringa);
short int num_par,inizioparentesi,fineparentesi,tipoparentesi,numcodepar;
num_par=CommandCode;

p=p+DIM_COMMAND_STRING;

// 2)Leggo inizio e fine delle parentesi 		   
while (num_par>0) 
{
	strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
	CommandStringa[DIM_COMMAND_STRING] = '\0';
	CommandCode = DecodeCommand(CommandStringa);        
	tipoparentesi=CommandCode;
	
	p=p+DIM_COMMAND_STRING;
	
	strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
	CommandStringa[DIM_COMMAND_STRING] = '\0';
	CommandCode = DecodeCommand(CommandStringa);        
	inizioparentesi=CommandCode;
	
	p=p+DIM_COMMAND_STRING;
	
	strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
	CommandStringa[DIM_COMMAND_STRING] = '\0';
	CommandCode = DecodeCommand(CommandStringa);        
	fineparentesi=CommandCode;
	
	p=p+DIM_COMMAND_STRING;
	
	strncpy(CommandStringa,p,DIM_COMMAND_STRING); 
	CommandStringa[DIM_COMMAND_STRING] = '\0';
	CommandCode = DecodeCommand(CommandStringa);        
	numcodepar=CommandCode;
	
	p=p+DIM_COMMAND_STRING;
	
	if (tipoparentesi == CL_PARGRAFFA)
	{
		AddParentesiGraffa(inizioparentesi, fineparentesi, numcodepar);
	}
	else if (tipoparentesi == CL_PARQUADRA)
	{
		AddParentesiQuadra(inizioparentesi, fineparentesi, numcodepar);
	}
	
	num_par--; 
}

