#if !defined(_PCMSTREAM_h)  // Sentry, use file only if it's not already included.
#define _PCMSTREAM_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       PCMStream.h
AUTHOR:     Bellini
OVERVIEW:   Declaration of SMRmpeg, the class that handles SMRmpeg streams
-------------------------------------------------------------------------*/
#include "MuxStream.h"

class PCMStream : public Stream
{
	int m_cNext;
	long m_lTime, m_lDTS;
	int m_nCount;
	int m_nFrameSize;
public:
	PCMStream (FILE *fStream, ESDesc *pDescriptor);
	virtual long GetDTS (long lNow = 0);
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
};
#endif