#if !defined(_SMR_h)  // Sentry, use file only if it's not already included.
#define _SMR_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       H263.h
AUTHOR:     Casucci & Claverini
OVERVIEW:   Declaration of SMRmpeg, the class that handles SMRmpeg streams
-------------------------------------------------------------------------*/
#include "MuxStream.h"

class SMRmpegStream : public Stream
{
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;
	FILE* m_timeFile;
	float m_prevTime[2];
	int m_prevChar[2];
//	int m_nextChar;
//	int m_readAhead;
	long m_lDTS;
	bool m_bRAP;

public:
	SMRmpegStream (FILE *fStream, ESDesc *pDescriptor);
	~SMRmpegStream ();
	virtual long GetDTS ();
	virtual long GetCTS () {return m_lDTS;}
	virtual bool IsRAP ();
	virtual int GetChar ();
};
#endif